(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/a11y'), require('@angular/cdk/portal'), require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/core'), require('@ng-tangram/components/overlay'), require('rxjs/operators'), require('rxjs'), require('@angular/forms'), require('@angular/cdk/coercion'), require('@angular/animations'), require('@ng-tangram/components/forms'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/datepicker', ['exports', '@angular/cdk/a11y', '@angular/cdk/portal', '@angular/common', '@angular/core', '@ng-tangram/components/core', '@ng-tangram/components/overlay', 'rxjs/operators', 'rxjs', '@angular/forms', '@angular/cdk/coercion', '@angular/animations', '@ng-tangram/components/forms', '@angular/cdk/overlay'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.datepicker = {}), global.ng.cdk.a11y, global.ng.cdk.portal, global.ng.common, global.ng.core, global.nt.components.core, global.nt.components.overlay, global.rxjs.operators, global.rxjs, global.ng.forms, global.ng.cdk.coercion, global.ng.animations, global.nt.components.forms, global.ng.cdk.overlay));
}(this, (function (exports, a11y, portal, common, core, core$1, overlay, operators, rxjs, forms, coercion, animations, forms$1, overlay$1) { 'use strict';

    var yearsPerPage = 12;
    var yearsPerRow = 3;
    function isSameMultiYearView(dateAdapter, date1, date2, minDate, maxDate) {
        var year1 = dateAdapter.getYear(date1);
        var year2 = dateAdapter.getYear(date2);
        var startingYear = getStartingYear(dateAdapter, minDate, maxDate);
        return Math.floor((year1 - startingYear) / yearsPerPage) ===
            Math.floor((year2 - startingYear) / yearsPerPage);
    }
    function getActiveOffset(dateAdapter, activeDate, minDate, maxDate) {
        var activeYear = dateAdapter.getYear(activeDate);
        return euclideanModulo((activeYear - getStartingYear(dateAdapter, minDate, maxDate)), yearsPerPage);
    }
    function getStartingYear(dateAdapter, minDate, maxDate) {
        var startingYear = 0;
        if (maxDate) {
            var maxYear = dateAdapter.getYear(maxDate);
            startingYear = maxYear - yearsPerPage + 1;
        }
        else if (minDate) {
            startingYear = dateAdapter.getYear(minDate);
        }
        return startingYear;
    }
    function euclideanModulo(a, b) {
        return (a % b + b) % b;
    }
    function isTableCell(node) {
        return node.nodeName === 'TD';
    }
    function isStart(value, start, end) {
        return end !== null && start !== end && value < end && value === start;
    }
    function isEnd(value, start, end) {
        return start !== null && start !== end && value >= start && value === end;
    }
    function isInRange(value, start, end, rangeEnabled) {
        return rangeEnabled && start !== null && end !== null && start !== end &&
            value >= start && value <= end;
    }

    var NtCalendarCell = /** @class */ (function () {
        function NtCalendarCell(value, displayValue, enabled, cssClasses, compareValue, rawValue) {
            if (cssClasses === void 0) { cssClasses = {}; }
            if (compareValue === void 0) { compareValue = value; }
            this.value = value;
            this.displayValue = displayValue;
            this.enabled = enabled;
            this.cssClasses = cssClasses;
            this.compareValue = compareValue;
            this.rawValue = rawValue;
        }
        return NtCalendarCell;
    }());
    var NtCalendarBody = /** @class */ (function () {
        function NtCalendarBody(_elementRef, _ngZone) {
            var _this = this;
            this._elementRef = _elementRef;
            this._ngZone = _ngZone;
            this.numCols = 7;
            this.activeCell = 0;
            this.isRange = false;
            this.cellAspectRatio = 1;
            this.previewStart = null;
            this.previewEnd = null;
            this.selectedValueChange = new core.EventEmitter();
            this.previewChange = new core.EventEmitter();
            this._enterHandler = function (event) {
                if (_this._skipNextFocus && event.type === 'focus') {
                    _this._skipNextFocus = false;
                    return;
                }
                if (event.target && _this.isRange) {
                    var cell_1 = _this._getCellFromElement(event.target);
                    if (cell_1) {
                        _this._ngZone.run(function () { return _this.previewChange.emit({ value: cell_1.enabled ? cell_1 : null, event: event }); });
                    }
                }
            };
            this._leaveHandler = function (event) {
                if (_this.previewEnd !== null && _this.isRange) {
                    if (event.target && isTableCell(event.target)) {
                        _this._ngZone.run(function () { return _this.previewChange.emit({ value: null, event: event }); });
                    }
                }
            };
            _ngZone.runOutsideAngular(function () {
                var element = _elementRef.nativeElement;
                element.addEventListener('mouseenter', _this._enterHandler, true);
                element.addEventListener('focus', _this._enterHandler, true);
                element.addEventListener('mouseleave', _this._leaveHandler, true);
                element.addEventListener('blur', _this._leaveHandler, true);
            });
        }
        NtCalendarBody.prototype._cellClicked = function (cell, event) {
            if (cell.enabled) {
                this.selectedValueChange.emit({ value: cell.value, event: event });
            }
        };
        NtCalendarBody.prototype._isSelected = function (value) {
            return this.startValue === value || this.endValue === value;
        };
        NtCalendarBody.prototype.ngOnChanges = function (changes) {
            var columnChanges = changes['numCols'];
            var _a = this, rows = _a.rows, numCols = _a.numCols;
            if (changes['rows'] || columnChanges) {
                this._firstRowOffset = rows && rows.length && rows[0].length ? numCols - rows[0].length : 0;
            }
            if (changes['cellAspectRatio'] || columnChanges || !this._cellPadding) {
                this._cellPadding = 50 * this.cellAspectRatio / numCols + "%";
            }
            if (columnChanges || !this._cellWidth) {
                this._cellWidth = 100 / numCols + "%";
            }
        };
        NtCalendarBody.prototype.ngOnDestroy = function () {
            var element = this._elementRef.nativeElement;
            element.removeEventListener('mouseenter', this._enterHandler, true);
            element.removeEventListener('focus', this._enterHandler, true);
            element.removeEventListener('mouseleave', this._leaveHandler, true);
            element.removeEventListener('blur', this._leaveHandler, true);
        };
        NtCalendarBody.prototype._isActiveCell = function (rowIndex, colIndex) {
            var cellNumber = rowIndex * this.numCols + colIndex;
            if (rowIndex) {
                cellNumber -= this._firstRowOffset;
            }
            return cellNumber == this.activeCell;
        };
        NtCalendarBody.prototype._focusActiveCell = function (movePreview) {
            var _this = this;
            if (movePreview === void 0) { movePreview = true; }
            this._ngZone.runOutsideAngular(function () {
                _this._ngZone.onStable.pipe(operators.take(1)).subscribe(function () {
                    var activeCell = _this._elementRef.nativeElement.querySelector('.nt-calendar-body-active');
                    if (activeCell) {
                        if (!movePreview) {
                            _this._skipNextFocus = true;
                        }
                        activeCell.focus();
                    }
                });
            });
        };
        NtCalendarBody.prototype._isRangeStart = function (value) {
            return isStart(value, this.startValue, this.endValue);
        };
        NtCalendarBody.prototype._isRangeEnd = function (value) {
            return isEnd(value, this.startValue, this.endValue);
        };
        NtCalendarBody.prototype._isInRange = function (value) {
            return isInRange(value, this.startValue, this.endValue, this.isRange);
        };
        NtCalendarBody.prototype._isComparisonStart = function (value) {
            return isStart(value, this.comparisonStart, this.comparisonEnd);
        };
        NtCalendarBody.prototype._isComparisonBridgeStart = function (value, rowIndex, colIndex) {
            if (!this._isComparisonStart(value) || this._isRangeStart(value) || !this._isInRange(value)) {
                return false;
            }
            var previousCell = this.rows[rowIndex][colIndex - 1];
            if (!previousCell) {
                var previousRow = this.rows[rowIndex - 1];
                previousCell = previousRow && previousRow[previousRow.length - 1];
            }
            return previousCell && !this._isRangeEnd(previousCell.compareValue);
        };
        NtCalendarBody.prototype._isComparisonBridgeEnd = function (value, rowIndex, colIndex) {
            if (!this._isComparisonEnd(value) || this._isRangeEnd(value) || !this._isInRange(value)) {
                return false;
            }
            var nextCell = this.rows[rowIndex][colIndex + 1];
            if (!nextCell) {
                var nextRow = this.rows[rowIndex + 1];
                nextCell = nextRow && nextRow[0];
            }
            return nextCell && !this._isRangeStart(nextCell.compareValue);
        };
        NtCalendarBody.prototype._isComparisonEnd = function (value) {
            return isEnd(value, this.comparisonStart, this.comparisonEnd);
        };
        NtCalendarBody.prototype._isInComparisonRange = function (value) {
            return isInRange(value, this.comparisonStart, this.comparisonEnd, this.isRange);
        };
        NtCalendarBody.prototype._isComparisonIdentical = function (value) {
            return this.comparisonStart === this.comparisonEnd && value === this.comparisonStart;
        };
        NtCalendarBody.prototype._isPreviewStart = function (value) {
            return isStart(value, this.previewStart, this.previewEnd);
        };
        NtCalendarBody.prototype._isPreviewEnd = function (value) {
            return isEnd(value, this.previewStart, this.previewEnd);
        };
        NtCalendarBody.prototype._isInPreview = function (value) {
            return isInRange(value, this.previewStart, this.previewEnd, this.isRange);
        };
        NtCalendarBody.prototype._getCellFromElement = function (element) {
            var cell;
            if (isTableCell(element)) {
                cell = element;
            }
            else if (isTableCell(element.parentNode)) {
                cell = element.parentNode;
            }
            if (cell) {
                var row = cell.getAttribute('data-nt-row');
                var col = cell.getAttribute('data-nt-col');
                if (row && col) {
                    return this.rows[parseInt(row)][parseInt(col)];
                }
            }
            return null;
        };
        return NtCalendarBody;
    }());
    NtCalendarBody.decorators = [
        { type: core.Component, args: [{
                    selector: '[nt-calendar-body]',
                    template: "<!-- Create the first row separately so we can include a special spacer cell. -->\n<tr *ngFor=\"let row of rows; let rowIndex = index\" role=\"row\">\n  <td *ngFor=\"let item of row; let colIndex = index\"\n      role=\"gridcell\"\n      class=\"nt-calendar-cell\"\n      [ngClass]=\"item.cssClasses\"\n      [tabindex]=\"_isActiveCell(rowIndex, colIndex) ? 0 : -1\"\n      [attr.data-nt-row]=\"rowIndex\"\n      [attr.data-nt-col]=\"colIndex\"\n      [class.nt-calendar-cell-disabled]=\"!item.enabled\"\n      [class.nt-calendar-cell-active]=\"_isActiveCell(rowIndex, colIndex)\"\n      [class.nt-calendar-cell-range-start]=\"_isRangeStart(item.compareValue)\"\n      [class.nt-calendar-cell-range-end]=\"_isRangeEnd(item.compareValue)\"\n      [class.nt-calendar-cell-in-range]=\"_isInRange(item.compareValue)\"\n      [class.nt-calendar-cell-comparison-bridge-start]=\"_isComparisonBridgeStart(item.compareValue, rowIndex, colIndex)\"\n      [class.nt-calendar-cell-comparison-bridge-end]=\"_isComparisonBridgeEnd(item.compareValue, rowIndex, colIndex)\"\n      [class.nt-calendar-cell-comparison-start]=\"_isComparisonStart(item.compareValue)\"\n      [class.nt-calendar-cell-comparison-end]=\"_isComparisonEnd(item.compareValue)\"\n      [class.nt-calendar-cell-in-comparison-range]=\"_isInComparisonRange(item.compareValue)\"\n      [class.nt-calendar-cell-preview-start]=\"_isPreviewStart(item.compareValue)\"\n      [class.nt-calendar-cell-preview-end]=\"_isPreviewEnd(item.compareValue)\"\n      [class.nt-calendar-cell-in-preview]=\"_isInPreview(item.compareValue)\"\n      (click)=\"_cellClicked(item, $event)\">\n      <span class=\"nt-calendar-cell-content nt-focus-indicator\"\n        [class.nt-calendar-cell-selected]=\"_isSelected(item.compareValue)\"\n        [class.nt-calendar-cell-comparison-identical]=\"_isComparisonIdentical(item.compareValue)\"\n        [class.nt-calendar-cell-today]=\"todayValue === item.compareValue\">\n        {{item.displayValue}}\n      </span>\n      <div class=\"nt-calendar-body-cell-preview\"></div>\n  </td>\n</tr>\n",
                    host: {
                        'class': 'nt-calendar-body'
                    },
                    exportAs: 'ntCalendarBody',
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NtCalendarBody.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.NgZone }
    ]; };
    NtCalendarBody.propDecorators = {
        label: [{ type: core.Input }],
        rows: [{ type: core.Input }],
        todayValue: [{ type: core.Input }],
        startValue: [{ type: core.Input }],
        endValue: [{ type: core.Input }],
        numCols: [{ type: core.Input }],
        activeCell: [{ type: core.Input }],
        isRange: [{ type: core.Input }],
        cellAspectRatio: [{ type: core.Input }],
        comparisonStart: [{ type: core.Input }],
        comparisonEnd: [{ type: core.Input }],
        previewStart: [{ type: core.Input }],
        previewEnd: [{ type: core.Input }],
        selectedValueChange: [{ type: core.Output }],
        previewChange: [{ type: core.Output }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var DateRange = /** @class */ (function () {
        function DateRange(start, end) {
            this.start = start;
            this.end = end;
        }
        return DateRange;
    }());
    var NtDateSelectionModel = /** @class */ (function () {
        function NtDateSelectionModel(selection, _adapter) {
            this.selection = selection;
            this._adapter = _adapter;
            this._selectionChanged = new rxjs.Subject();
            this.selectionChanged = this._selectionChanged;
            this.selection = selection;
        }
        NtDateSelectionModel.prototype.updateSelection = function (value, source) {
            this.selection = value;
            this._selectionChanged.next({ selection: value, source: source });
        };
        NtDateSelectionModel.prototype.ngOnDestroy = function () {
            this._selectionChanged.complete();
        };
        NtDateSelectionModel.prototype._isValidDateInstance = function (date) {
            return this._adapter.isDateInstance(date) && this._adapter.isValid(date);
        };
        return NtDateSelectionModel;
    }());
    NtDateSelectionModel.decorators = [
        { type: core.Directive }
    ];
    NtDateSelectionModel.ctorParameters = function () { return [
        { type: undefined },
        { type: core$1.DateAdapter }
    ]; };
    var NtSingleDateSelectionModel = /** @class */ (function (_super) {
        __extends(NtSingleDateSelectionModel, _super);
        function NtSingleDateSelectionModel(adapter) {
            return _super.call(this, null, adapter) || this;
        }
        NtSingleDateSelectionModel.prototype.add = function (date) {
            _super.prototype.updateSelection.call(this, date, this);
        };
        NtSingleDateSelectionModel.prototype.isValid = function () {
            return this.selection != null && this._isValidDateInstance(this.selection);
        };
        NtSingleDateSelectionModel.prototype.isComplete = function () {
            return this.selection != null;
        };
        return NtSingleDateSelectionModel;
    }(NtDateSelectionModel));
    NtSingleDateSelectionModel.decorators = [
        { type: core.Injectable }
    ];
    NtSingleDateSelectionModel.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    var NtRangeDateSelectionModel = /** @class */ (function (_super) {
        __extends(NtRangeDateSelectionModel, _super);
        function NtRangeDateSelectionModel(adapter) {
            return _super.call(this, new DateRange(null, null), adapter) || this;
        }
        NtRangeDateSelectionModel.prototype.add = function (date) {
            var _a = this.selection, start = _a.start, end = _a.end;
            if (start == null) {
                start = date;
            }
            else if (end == null) {
                end = date;
            }
            else {
                start = date;
                end = null;
            }
            _super.prototype.updateSelection.call(this, new DateRange(start, end), this);
        };
        NtRangeDateSelectionModel.prototype.isValid = function () {
            var _a = this.selection, start = _a.start, end = _a.end;
            if (start == null && end == null) {
                return true;
            }
            if (start != null && end != null) {
                return this._isValidDateInstance(start) && this._isValidDateInstance(end) &&
                    this._adapter.compareDate(start, end) <= 0;
            }
            return (start == null || this._isValidDateInstance(start)) &&
                (end == null || this._isValidDateInstance(end));
        };
        NtRangeDateSelectionModel.prototype.isComplete = function () {
            return this.selection.start != null && this.selection.end != null;
        };
        return NtRangeDateSelectionModel;
    }(NtDateSelectionModel));
    NtRangeDateSelectionModel.decorators = [
        { type: core.Injectable }
    ];
    NtRangeDateSelectionModel.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    function NT_SINGLE_DATE_SELECTION_MODEL_FACTORY(parent, adapter) {
        return parent || new NtSingleDateSelectionModel(adapter);
    }
    var NT_SINGLE_DATE_SELECTION_MODEL_PROVIDER = {
        provide: NtDateSelectionModel,
        deps: [[new core.Optional(), new core.SkipSelf(), NtDateSelectionModel], core$1.DateAdapter],
        useFactory: NT_SINGLE_DATE_SELECTION_MODEL_FACTORY,
    };
    function NT_RANGE_DATE_SELECTION_MODEL_FACTORY(parent, adapter) {
        return parent || new NtRangeDateSelectionModel(adapter);
    }
    var NT_RANGE_DATE_SELECTION_MODEL_PROVIDER = {
        provide: NtDateSelectionModel,
        deps: [[new core.Optional(), new core.SkipSelf(), NtDateSelectionModel], core$1.DateAdapter],
        useFactory: NT_RANGE_DATE_SELECTION_MODEL_FACTORY,
    };

    var NT_DATE_RANGE_SELECTION_STRATEGY = new core.InjectionToken('NT_DATE_RANGE_SELECTION_STRATEGY');
    var DefaultNtCalendarRangeStrategy = /** @class */ (function () {
        function DefaultNtCalendarRangeStrategy(_dateAdapter) {
            this._dateAdapter = _dateAdapter;
        }
        DefaultNtCalendarRangeStrategy.prototype.selectionFinished = function (date, currentRange) {
            var start = currentRange.start, end = currentRange.end;
            if (start == null) {
                start = date;
            }
            else if (end == null && date) {
                if (this._dateAdapter.compareDate(date, start) >= 0) {
                    end = date;
                }
                else {
                    start = date;
                    end = currentRange.start;
                }
            }
            else {
                start = date;
                end = null;
            }
            return new DateRange(start, end);
        };
        DefaultNtCalendarRangeStrategy.prototype.createPreview = function (activeDate, currentRange) {
            var start = null;
            var end = null;
            if (currentRange.start && !currentRange.end && activeDate) {
                start = currentRange.start;
                end = activeDate;
                if (this._dateAdapter.compareDate(activeDate, start) < 0) {
                    start = activeDate;
                    end = currentRange.start;
                }
            }
            return new DateRange(start, end);
        };
        return DefaultNtCalendarRangeStrategy;
    }());
    DefaultNtCalendarRangeStrategy.decorators = [
        { type: core.Injectable }
    ];
    DefaultNtCalendarRangeStrategy.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    function NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY(parent, adapter) {
        return parent || new DefaultNtCalendarRangeStrategy(adapter);
    }
    var NT_CALENDAR_RANGE_STRATEGY_PROVIDER = {
        provide: NT_DATE_RANGE_SELECTION_STRATEGY,
        deps: [[new core.Optional(), new core.SkipSelf(), NT_DATE_RANGE_SELECTION_STRATEGY], core$1.DateAdapter],
        useFactory: NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY,
    };

    var WeeklyNtCalendarRangeStrategy = /** @class */ (function () {
        function WeeklyNtCalendarRangeStrategy(_dateAdapter) {
            this._dateAdapter = _dateAdapter;
        }
        WeeklyNtCalendarRangeStrategy.prototype.selectionFinished = function (date) {
            if (date) {
                return this._getRangeRelativeToDate(date);
            }
            return new DateRange(null, null);
        };
        WeeklyNtCalendarRangeStrategy.prototype.createPreview = function (activeDate) {
            if (activeDate) {
                return this._getRangeRelativeToDate(activeDate);
            }
            return new DateRange(null, null);
        };
        WeeklyNtCalendarRangeStrategy.prototype._getRangeRelativeToDate = function (date) {
            var rangeStart = null;
            var rangeEnd = null;
            if (date) {
                var firstDayOfWeek = this._dateAdapter.getFirstDayOfWeek();
                var dayOfWeek = this._dateAdapter.getDayOfWeek(date);
                rangeStart = this._dateAdapter.addCalendarDays(date, firstDayOfWeek - dayOfWeek);
                rangeEnd = this._dateAdapter.addCalendarDays(date, 6 - dayOfWeek);
            }
            return new DateRange(rangeStart, rangeEnd);
        };
        return WeeklyNtCalendarRangeStrategy;
    }());
    WeeklyNtCalendarRangeStrategy.decorators = [
        { type: core.Injectable }
    ];
    WeeklyNtCalendarRangeStrategy.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    function WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY(parent, adapter) {
        return parent || new WeeklyNtCalendarRangeStrategy(adapter);
    }
    var WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER = {
        provide: NT_DATE_RANGE_SELECTION_STRATEGY,
        deps: [[new core.Optional(), new core.SkipSelf(), NT_DATE_RANGE_SELECTION_STRATEGY], core$1.DateAdapter],
        useFactory: WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY,
    };

    var MonthlyNtCalendarRangeStrategy = /** @class */ (function () {
        function MonthlyNtCalendarRangeStrategy(_dateAdapter) {
            this._dateAdapter = _dateAdapter;
        }
        MonthlyNtCalendarRangeStrategy.prototype.selectionFinished = function (date) {
            if (date) {
                return this._getRangeRelativeToDate(date);
            }
            return new DateRange(null, null);
        };
        MonthlyNtCalendarRangeStrategy.prototype.createPreview = function (activeDate) {
            if (activeDate) {
                return this._getRangeRelativeToDate(activeDate);
            }
            return new DateRange(null, null);
        };
        MonthlyNtCalendarRangeStrategy.prototype._getRangeRelativeToDate = function (date) {
            var rangeStart = null;
            var rangeEnd = null;
            if (date) {
                var year = this._dateAdapter.getYear(date);
                var month = this._dateAdapter.getMonth(date);
                var monthDays = this._dateAdapter.getNumDaysInMonth(date);
                rangeStart = this._dateAdapter.createDate(year, month, 1);
                rangeEnd = this._dateAdapter.createDate(year, month, monthDays);
            }
            return new DateRange(rangeStart, rangeEnd);
        };
        return MonthlyNtCalendarRangeStrategy;
    }());
    MonthlyNtCalendarRangeStrategy.decorators = [
        { type: core.Injectable }
    ];
    MonthlyNtCalendarRangeStrategy.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    function MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY(parent, adapter) {
        return parent || new MonthlyNtCalendarRangeStrategy(adapter);
    }
    var MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER = {
        provide: NT_DATE_RANGE_SELECTION_STRATEGY,
        deps: [[new core.Optional(), new core.SkipSelf(), NT_DATE_RANGE_SELECTION_STRATEGY], core$1.DateAdapter],
        useFactory: MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY,
    };

    function createMissingDateImplError(provider) {
        return Error("NtDatepickerComponent: No provider found for " + provider + ". You must import one of the following " +
            "modules at your application root: NtNativeDateModule or provide a " +
            "custom implementation.");
    }

    var DAYS_PER_WEEK = 7;
    var DAYS_MAX_ROWS = 6;
    var NtCalendarMonth = /** @class */ (function () {
        function NtCalendarMonth(_changeDetectorRef, _dateAdapter, _dateFormats, _rangeStrategy) {
            this._changeDetectorRef = _changeDetectorRef;
            this._dateAdapter = _dateAdapter;
            this._dateFormats = _dateFormats;
            this._rangeStrategy = _rangeStrategy;
            this._rerenderSubscription = rxjs.Subscription.EMPTY;
            this.selectedChange = new core.EventEmitter();
            this._userSelection = new core.EventEmitter();
            this.activeDateChange = new core.EventEmitter();
            if (!this._dateAdapter) {
                throw createMissingDateImplError('DateAdapter');
            }
            if (!this._dateFormats) {
                throw createMissingDateImplError('NT_DATE_FORMATS');
            }
            var firstDayOfWeek = this._dateAdapter.getFirstDayOfWeek();
            var narrowWeekdays = this._dateAdapter.getDayOfWeekNames('narrow');
            var longWeekdays = this._dateAdapter.getDayOfWeekNames('long');
            var weekdays = longWeekdays.map(function (long, i) {
                return { long: long, narrow: narrowWeekdays[i] };
            });
            this._weekdays = weekdays.slice(firstDayOfWeek).concat(weekdays.slice(0, firstDayOfWeek));
            this._activeDate = this._dateAdapter.today();
        }
        Object.defineProperty(NtCalendarMonth.prototype, "activeDate", {
            get: function () { return this._activeDate; },
            set: function (value) {
                var oldActiveDate = this._activeDate;
                var validDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)) || this._dateAdapter.today();
                this._activeDate = this._dateAdapter.clampDate(validDate, this.minDate, this.maxDate);
                if (!this._hasSameMonthAndYear(oldActiveDate, this._activeDate)) {
                    this._init();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMonth.prototype, "selected", {
            get: function () { return this._selected; },
            set: function (value) {
                if (value instanceof DateRange) {
                    this._selected = value;
                }
                else {
                    this._selected = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
                }
                this._setRanges(this._selected);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMonth.prototype, "minDate", {
            get: function () { return this._minDate; },
            set: function (value) {
                this._minDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMonth.prototype, "maxDate", {
            get: function () { return this._maxDate; },
            set: function (value) {
                this._maxDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        NtCalendarMonth.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._rerenderSubscription = this._dateAdapter.localeChanges
                .pipe(operators.startWith(null))
                .subscribe(function () { return _this._init(); });
        };
        NtCalendarMonth.prototype.ngOnChanges = function (changes) {
            var comparisonChange = changes['comparisonStart'] || changes['comparisonEnd'];
            if (comparisonChange && !comparisonChange.firstChange) {
                this._setRanges(this.selected);
            }
        };
        NtCalendarMonth.prototype.ngOnDestroy = function () {
            this._rerenderSubscription.unsubscribe();
        };
        NtCalendarMonth.prototype._dateSelected = function (event) {
            var date = event.value;
            var selectedYear = this._dateAdapter.getYear(this.activeDate);
            var selectedMonth = this._dateAdapter.getMonth(this.activeDate);
            var selectedDate = this._dateAdapter.createDate(selectedYear, selectedMonth, date);
            var rangeStartDate;
            var rangeEndDate;
            if (this._selected instanceof DateRange) {
                rangeStartDate = this._getDateInCurrentMonth(this._selected.start);
                rangeEndDate = this._getDateInCurrentMonth(this._selected.end);
            }
            else {
                rangeStartDate = rangeEndDate = this._getDateInCurrentMonth(this._selected);
            }
            if (rangeStartDate !== date || rangeEndDate !== date) {
                this.selectedChange.emit(selectedDate);
            }
            this._userSelection.emit({ value: selectedDate, event: event.event });
        };
        NtCalendarMonth.prototype._init = function () {
            this._setRanges(this.selected);
            this._todayDate = this._getCellCompareValue(this._dateAdapter.today());
            this._monthLabel =
                this._dateAdapter.getMonthNames('short')[this._dateAdapter.getMonth(this.activeDate)]
                    .toLocaleUpperCase();
            var firstOfMonth = this._dateAdapter.createDate(this._dateAdapter.getYear(this.activeDate), this._dateAdapter.getMonth(this.activeDate), 1);
            this._firstWeekOffset =
                (DAYS_PER_WEEK + this._dateAdapter.getDayOfWeek(firstOfMonth) -
                    this._dateAdapter.getFirstDayOfWeek()) % DAYS_PER_WEEK;
            this._initWeekdays();
            this._createWeekCells();
            this._changeDetectorRef.markForCheck();
        };
        NtCalendarMonth.prototype._focusActiveCell = function (movePreview) {
            this._calendarBody._focusActiveCell(movePreview);
        };
        NtCalendarMonth.prototype._previewChanged = function (_a) {
            var event = _a.event, cell = _a.value;
            if (this._rangeStrategy) {
                var value = cell ? cell.rawValue : null;
                var previewRange = this._rangeStrategy.createPreview(value, this.selected, event);
                this._previewStart = this._getCellCompareValue(previewRange.start);
                this._previewEnd = this._getCellCompareValue(previewRange.end);
                this._changeDetectorRef.detectChanges();
            }
        };
        NtCalendarMonth.prototype._initWeekdays = function () {
            var firstDayOfWeek = this._dateAdapter.getFirstDayOfWeek();
            var narrowWeekdays = this._dateAdapter.getDayOfWeekNames('narrow');
            var longWeekdays = this._dateAdapter.getDayOfWeekNames('long');
            var weekdays = longWeekdays.map(function (long, i) {
                return { long: long, narrow: narrowWeekdays[i] };
            });
            this._weekdays = weekdays.slice(firstDayOfWeek).concat(weekdays.slice(0, firstDayOfWeek));
        };
        NtCalendarMonth.prototype._createWeekCells = function () {
            var daysInMonth = this._dateAdapter.getNumDaysInMonth(this.activeDate);
            var dateNames = this._dateAdapter.getDateNames();
            this._weeks = [[]];
            for (var i = 0, cell = this._firstWeekOffset; i < daysInMonth; i++, cell++) {
                if (cell == DAYS_PER_WEEK) {
                    this._weeks.push([]);
                    cell = 0;
                }
                var date = this._dateAdapter.createDate(this._dateAdapter.getYear(this.activeDate), this._dateAdapter.getMonth(this.activeDate), i + 1);
                var enabled = this._shouldEnableDate(date);
                var cellClasses = this.dateClass ? this.dateClass(date, 'month') : undefined;
                this._weeks[this._weeks.length - 1].push(new NtCalendarCell(i + 1, dateNames[i], enabled, cellClasses, this._getCellCompareValue(date), date));
            }
            this._fillBeforeCells();
            this._fillAfterCells();
        };
        NtCalendarMonth.prototype._fillBeforeCells = function () {
            var beforeMonth = this._dateAdapter.addCalendarMonths(this._dateAdapter.clone(this.activeDate), -1);
            var daysInBeforeMonth = this._dateAdapter.getNumDaysInMonth(beforeMonth);
            var dateNames = this._dateAdapter.getDateNames();
            var beforeWeeks = [];
            for (var i = daysInBeforeMonth - this._firstWeekOffset; i < daysInBeforeMonth; i++) {
                beforeWeeks.push(new NtCalendarCell(i + 1, dateNames[i], false));
            }
            this._weeks[0] = beforeWeeks.concat(this._weeks[0]);
        };
        NtCalendarMonth.prototype._fillAfterCells = function () {
            var _a;
            var afterMonth = this._dateAdapter.addCalendarMonths(this._dateAdapter.clone(this.activeDate), 1);
            var lastRow = this._weeks[this._weeks.length - 1];
            var dateNames = this._dateAdapter.getDateNames();
            var afterWeeks = [], afterRows = [];
            for (var i = 0; i < DAYS_PER_WEEK - lastRow.length; i++) {
                afterWeeks.push(new NtCalendarCell(i + 1, dateNames[i], false));
            }
            lastRow.push.apply(lastRow, __spread(afterWeeks));
            for (var i = 0; i < DAYS_PER_WEEK * (DAYS_MAX_ROWS - this._weeks.length); i++) {
                afterRows.push(new NtCalendarCell(afterWeeks.length + i + 1, dateNames[afterWeeks.length + i], false));
            }
            (_a = this._weeks).push.apply(_a, __spread(afterRows.map(function (_) { return afterRows.splice(0, DAYS_PER_WEEK); }).filter(function (row) { return !!row; })));
        };
        NtCalendarMonth.prototype._shouldEnableDate = function (date) {
            return !!date &&
                (!this.minDate || this._dateAdapter.compareDate(date, this.minDate) >= 0) &&
                (!this.maxDate || this._dateAdapter.compareDate(date, this.maxDate) <= 0) &&
                (!this.dateFilter || this.dateFilter(date));
        };
        NtCalendarMonth.prototype._getDateInCurrentMonth = function (date) {
            return date && this._hasSameMonthAndYear(date, this.activeDate) ?
                this._dateAdapter.getDate(date) : null;
        };
        NtCalendarMonth.prototype._hasSameMonthAndYear = function (d1, d2) {
            return !!(d1 && d2 && this._dateAdapter.getMonth(d1) == this._dateAdapter.getMonth(d2) &&
                this._dateAdapter.getYear(d1) == this._dateAdapter.getYear(d2));
        };
        NtCalendarMonth.prototype._getCellCompareValue = function (date) {
            if (date) {
                var year = this._dateAdapter.getYear(date);
                var month = this._dateAdapter.getMonth(date);
                var day = this._dateAdapter.getDate(date);
                return new Date(year, month, day).getTime();
            }
            return null;
        };
        NtCalendarMonth.prototype._setRanges = function (selectedValue) {
            if (selectedValue instanceof DateRange) {
                this._rangeStart = this._getCellCompareValue(selectedValue.start);
                this._rangeEnd = this._getCellCompareValue(selectedValue.end);
                this._isRange = true;
            }
            else {
                this._rangeStart = this._rangeEnd = this._getCellCompareValue(selectedValue);
                this._isRange = false;
            }
            this._comparisonRangeStart = this._getCellCompareValue(this.comparisonStart);
            this._comparisonRangeEnd = this._getCellCompareValue(this.comparisonEnd);
        };
        return NtCalendarMonth;
    }());
    NtCalendarMonth.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-calendar-month',
                    template: "<table>\n  <thead>\n    <tr>\n      <th *ngFor=\"let week of _weekdays;\" scope=\"col\">\n        {{week.narrow}}\n      </th>\n    </tr>\n  </thead>\n  <tbody nt-calendar-body\n    [label]=\"_monthLabel\"\n    [rows]=\"_weeks\"\n    [todayValue]=\"_todayDate!\"\n    [startValue]=\"_rangeStart!\"\n    [endValue]=\"_rangeEnd!\"\n    [comparisonStart]=\"_comparisonRangeStart\"\n    [comparisonEnd]=\"_comparisonRangeEnd\"\n    [previewStart]=\"_previewStart\"\n    [previewEnd]=\"_previewEnd\"\n    [isRange]=\"_isRange\"\n    [activeCell]=\"_dateAdapter.getDate(activeDate) - 1\"\n    (selectedValueChange)=\"_dateSelected($event)\"\n    (previewChange)=\"_previewChanged($event)\">\n  </tbody>\n</table>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-calendar-month'
                    }
                },] }
    ];
    NtCalendarMonth.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter, decorators: [{ type: core.Optional }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_DATE_RANGE_SELECTION_STRATEGY,] }, { type: core.Optional }] }
    ]; };
    NtCalendarMonth.propDecorators = {
        activeDate: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        comparisonStart: [{ type: core.Input }],
        comparisonEnd: [{ type: core.Input }],
        selectedChange: [{ type: core.Output }],
        _userSelection: [{ type: core.Output }],
        activeDateChange: [{ type: core.Output }],
        _calendarBody: [{ type: core.ViewChild, args: [NtCalendarBody,] }]
    };

    var NtCalendarMultiYear = /** @class */ (function () {
        function NtCalendarMultiYear(_changeDetectorRef, _dateAdapter) {
            this._changeDetectorRef = _changeDetectorRef;
            this._dateAdapter = _dateAdapter;
            this._rerenderSubscription = rxjs.Subscription.EMPTY;
            this.selectedChange = new core.EventEmitter();
            this.yearSelected = new core.EventEmitter();
            this.activeDateChange = new core.EventEmitter();
            if (!this._dateAdapter) {
                throw createMissingDateImplError('DateAdapter');
            }
            this._activeDate = this._dateAdapter.today();
        }
        Object.defineProperty(NtCalendarMultiYear.prototype, "activeDate", {
            get: function () { return this._activeDate; },
            set: function (value) {
                var oldActiveDate = this._activeDate;
                var validDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)) || this._dateAdapter.today();
                this._activeDate = this._dateAdapter.clampDate(validDate, this.minDate, this.maxDate);
                if (!isSameMultiYearView(this._dateAdapter, oldActiveDate, this._activeDate, this.minDate, this.maxDate)) {
                    this._init();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMultiYear.prototype, "selected", {
            get: function () { return this._selected; },
            set: function (value) {
                if (value instanceof DateRange) {
                    this._selected = value;
                }
                else {
                    this._selected = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
                }
                this._setSelectedYear(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMultiYear.prototype, "minDate", {
            get: function () { return this._minDate; },
            set: function (value) {
                this._minDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarMultiYear.prototype, "maxDate", {
            get: function () { return this._maxDate; },
            set: function (value) {
                this._maxDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        NtCalendarMultiYear.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._rerenderSubscription = this._dateAdapter.localeChanges
                .pipe(operators.startWith(null))
                .subscribe(function () { return _this._init(); });
        };
        NtCalendarMultiYear.prototype.ngOnDestroy = function () {
            this._rerenderSubscription.unsubscribe();
        };
        NtCalendarMultiYear.prototype._init = function () {
            var _this = this;
            this._todayYear = this._dateAdapter.getYear(this._dateAdapter.today());
            var activeYear = this._dateAdapter.getYear(this._activeDate);
            var activeOffset = activeYear % yearsPerPage;
            this._years = [];
            for (var i = 0, row = []; i < yearsPerPage; i++) {
                row.push(activeYear - activeOffset + i);
                if (row.length === yearsPerRow) {
                    this._years.push(row.map(function (year) { return _this._createCellForYear(year); }));
                    row = [];
                }
            }
            this._changeDetectorRef.markForCheck();
        };
        NtCalendarMultiYear.prototype._yearSelected = function (event) {
            var year = event.value;
            this.yearSelected.emit(this._dateAdapter.createDate(year, 0, 1));
            var month = this._dateAdapter.getMonth(this.activeDate);
            var daysInMonth = this._dateAdapter.getNumDaysInMonth(this._dateAdapter.createDate(year, month, 1));
            this.selectedChange.emit(this._dateAdapter.createDate(year, month, Math.min(this._dateAdapter.getDate(this.activeDate), daysInMonth)));
        };
        NtCalendarMultiYear.prototype._getActiveCell = function () {
            return getActiveOffset(this._dateAdapter, this.activeDate, this.minDate, this.maxDate);
        };
        NtCalendarMultiYear.prototype._focusActiveCell = function () {
            this._calendarBody._focusActiveCell();
        };
        NtCalendarMultiYear.prototype._createCellForYear = function (year) {
            var date = this._dateAdapter.createDate(year, 0, 1);
            var yearName = this._dateAdapter.getYearName(date);
            var cellClasses = this.dateClass ? this.dateClass(date, 'multi-year') : undefined;
            return new NtCalendarCell(year, yearName, this._shouldEnableYear(year), cellClasses);
        };
        NtCalendarMultiYear.prototype._shouldEnableYear = function (year) {
            if (year === undefined || year === null ||
                (this.maxDate && year > this._dateAdapter.getYear(this.maxDate)) ||
                (this.minDate && year < this._dateAdapter.getYear(this.minDate))) {
                return false;
            }
            if (!this.dateFilter) {
                return true;
            }
            var firstOfYear = this._dateAdapter.createDate(year, 0, 1);
            for (var date = firstOfYear; this._dateAdapter.getYear(date) === year; date = this._dateAdapter.addCalendarDays(date, 1)) {
                if (this.dateFilter(date)) {
                    return true;
                }
            }
            return false;
        };
        NtCalendarMultiYear.prototype._setSelectedYear = function (value) {
            this._selectedYear = null;
            if (value instanceof DateRange) {
                var displayValue = value.start || value.end;
                if (displayValue) {
                    this._selectedYear = this._dateAdapter.getYear(displayValue);
                }
            }
            else if (value) {
                this._selectedYear = this._dateAdapter.getYear(value);
            }
        };
        return NtCalendarMultiYear;
    }());
    NtCalendarMultiYear.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-calendar-multi-year',
                    template: "<table>\n  <tbody nt-calendar-body\n    [rows]=\"_years\"\n    [todayValue]=\"_todayYear\"\n    [startValue]=\"_selectedYear!\"\n    [endValue]=\"_selectedYear!\"\n    [numCols]=\"3\"\n    [cellAspectRatio]=\"3 / 7\"\n    [activeCell]=\"_getActiveCell()\"\n    (selectedValueChange)=\"_yearSelected($event)\">\n  </tbody>\n</table>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-calendar-multi-year'
                    }
                },] }
    ];
    NtCalendarMultiYear.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter, decorators: [{ type: core.Optional }] }
    ]; };
    NtCalendarMultiYear.propDecorators = {
        activeDate: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        selectedChange: [{ type: core.Output }],
        yearSelected: [{ type: core.Output }],
        activeDateChange: [{ type: core.Output }],
        _calendarBody: [{ type: core.ViewChild, args: [NtCalendarBody,] }]
    };

    var NtCalendarYear = /** @class */ (function () {
        function NtCalendarYear(_changeDetectorRef, _dateAdapter, _dateFormats) {
            this._changeDetectorRef = _changeDetectorRef;
            this._dateAdapter = _dateAdapter;
            this._dateFormats = _dateFormats;
            this._rerenderSubscription = rxjs.Subscription.EMPTY;
            this.selectedChange = new core.EventEmitter();
            this.monthSelected = new core.EventEmitter();
            this.activeDateChange = new core.EventEmitter();
            if (!this._dateAdapter) {
                throw createMissingDateImplError('DateAdapter');
            }
            if (!this._dateFormats) {
                throw createMissingDateImplError('NT_DATE_FORMATS');
            }
            this._activeDate = this._dateAdapter.today();
        }
        Object.defineProperty(NtCalendarYear.prototype, "activeDate", {
            get: function () { return this._activeDate; },
            set: function (value) {
                var oldActiveDate = this._activeDate;
                var validDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)) || this._dateAdapter.today();
                this._activeDate = this._dateAdapter.clampDate(validDate, this.minDate, this.maxDate);
                if (this._dateAdapter.getYear(oldActiveDate) !== this._dateAdapter.getYear(this._activeDate)) {
                    this._init();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarYear.prototype, "selected", {
            get: function () { return this._selected; },
            set: function (value) {
                if (value instanceof DateRange) {
                    this._selected = value;
                }
                else {
                    this._selected = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarYear.prototype, "minDate", {
            get: function () { return this._minDate; },
            set: function (value) {
                this._minDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarYear.prototype, "maxDate", {
            get: function () { return this._maxDate; },
            set: function (value) {
                this._maxDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        NtCalendarYear.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._rerenderSubscription = this._dateAdapter.localeChanges
                .pipe(operators.startWith(null))
                .subscribe(function () { return _this._init(); });
        };
        NtCalendarYear.prototype.ngOnDestroy = function () {
            this._rerenderSubscription.unsubscribe();
        };
        NtCalendarYear.prototype._init = function () {
            var _this = this;
            this._setSelectedMonth(this.selected);
            this._todayMonth = this._getMonthInCurrentYear(this._dateAdapter.today());
            this._yearLabel = this._dateAdapter.getYearName(this.activeDate);
            var monthNames = this._dateAdapter.getMonthNames('short');
            this._months = [[0, 1, 2], [3, 4, 5], [6, 7, 8], [9, 10, 11]].map(function (row) { return row.map(function (month) { return _this._createCellForMonth(month, monthNames[month]); }); });
            this._changeDetectorRef.markForCheck();
        };
        NtCalendarYear.prototype._monthSelected = function (event) {
            var month = event.value;
            var normalizedDate = this._dateAdapter.createDate(this._dateAdapter.getYear(this.activeDate), month, 1);
            this.monthSelected.emit(normalizedDate);
            var daysInMonth = this._dateAdapter.getNumDaysInMonth(normalizedDate);
            this.selectedChange.emit(this._dateAdapter.createDate(this._dateAdapter.getYear(this.activeDate), month, Math.min(this._dateAdapter.getDate(this.activeDate), daysInMonth)));
        };
        NtCalendarYear.prototype._focusActiveCell = function () {
            this._calendarBody._focusActiveCell();
        };
        NtCalendarYear.prototype._getMonthInCurrentYear = function (date) {
            return date && this._dateAdapter.getYear(date) == this._dateAdapter.getYear(this.activeDate) ?
                this._dateAdapter.getMonth(date) : null;
        };
        NtCalendarYear.prototype._createCellForMonth = function (month, monthName) {
            var date = this._dateAdapter.createDate(this._dateAdapter.getYear(this.activeDate), month, 1);
            var cellClasses = this.dateClass ? this.dateClass(date, 'year') : undefined;
            return new NtCalendarCell(month, monthName.toLocaleUpperCase(), this._shouldEnableMonth(month), cellClasses);
        };
        NtCalendarYear.prototype._shouldEnableMonth = function (month) {
            var activeYear = this._dateAdapter.getYear(this.activeDate);
            if (month === undefined || month === null ||
                this._isYearAndMonthAfterMaxDate(activeYear, month) ||
                this._isYearAndMonthBeforeMinDate(activeYear, month)) {
                return false;
            }
            if (!this.dateFilter) {
                return true;
            }
            var firstOfMonth = this._dateAdapter.createDate(activeYear, month, 1);
            for (var date = firstOfMonth; this._dateAdapter.getMonth(date) == month; date = this._dateAdapter.addCalendarDays(date, 1)) {
                if (this.dateFilter(date)) {
                    return true;
                }
            }
            return false;
        };
        NtCalendarYear.prototype._isYearAndMonthAfterMaxDate = function (year, month) {
            if (this.maxDate) {
                var maxYear = this._dateAdapter.getYear(this.maxDate);
                var maxMonth = this._dateAdapter.getMonth(this.maxDate);
                return year > maxYear || (year === maxYear && month > maxMonth);
            }
            return false;
        };
        NtCalendarYear.prototype._isYearAndMonthBeforeMinDate = function (year, month) {
            if (this.minDate) {
                var minYear = this._dateAdapter.getYear(this.minDate);
                var minMonth = this._dateAdapter.getMonth(this.minDate);
                return year < minYear || (year === minYear && month < minMonth);
            }
            return false;
        };
        NtCalendarYear.prototype._setSelectedMonth = function (value) {
            if (value instanceof DateRange) {
                this._selectedMonth = this._getMonthInCurrentYear(value.start) ||
                    this._getMonthInCurrentYear(value.end);
            }
            else {
                this._selectedMonth = this._getMonthInCurrentYear(value);
            }
        };
        return NtCalendarYear;
    }());
    NtCalendarYear.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-calendar-year',
                    template: "<table>\n  <tbody nt-calendar-body\n    [label]=\"_yearLabel\"\n    [rows]=\"_months\"\n    [todayValue]=\"_todayMonth!\"\n    [startValue]=\"_selectedMonth!\"\n    [endValue]=\"_selectedMonth!\"\n    [numCols]=\"3\"\n    [cellAspectRatio]=\"3 / 7\"\n    [activeCell]=\"_dateAdapter.getMonth(activeDate)\"\n    (selectedValueChange)=\"_monthSelected($event)\">\n  </tbody>\n</table>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-calendar-year'
                    }
                },] }
    ];
    NtCalendarYear.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter, decorators: [{ type: core.Optional }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] }
    ]; };
    NtCalendarYear.propDecorators = {
        activeDate: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        selectedChange: [{ type: core.Output }],
        monthSelected: [{ type: core.Output }],
        activeDateChange: [{ type: core.Output }],
        _calendarBody: [{ type: core.ViewChild, args: [NtCalendarBody,] }]
    };

    var NtDatePickerCalendar = /** @class */ (function () {
        function NtDatePickerCalendar(_changeDetectorRef, _dateAdapter, _dateFormats) {
            this._changeDetectorRef = _changeDetectorRef;
            this._dateAdapter = _dateAdapter;
            this._dateFormats = _dateFormats;
            this._moveFocusOnNextTick = false;
            this.startView = 'month';
            this.stateChanges = new rxjs.Subject();
            this.selectedChange = new core.EventEmitter();
            this.yearSelected = new core.EventEmitter();
            this.monthSelected = new core.EventEmitter();
            this.viewChanged = new core.EventEmitter(true);
            this._userSelection = new core.EventEmitter();
            if (!this._dateAdapter) {
                throw createMissingDateImplError('DateAdapter');
            }
            if (!this._dateFormats) {
                throw createMissingDateImplError('NT_DATE_FORMATS');
            }
        }
        Object.defineProperty(NtDatePickerCalendar.prototype, "startAt", {
            get: function () { return this._startAt; },
            set: function (value) {
                this._startAt = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerCalendar.prototype, "selected", {
            get: function () { return this._selected; },
            set: function (value) {
                if (value instanceof DateRange) {
                    this._selected = value;
                }
                else {
                    this._selected = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerCalendar.prototype, "minDate", {
            get: function () { return this._minDate; },
            set: function (value) {
                this._minDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerCalendar.prototype, "maxDate", {
            get: function () { return this._maxDate; },
            set: function (value) {
                this._maxDate = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerCalendar.prototype, "currentView", {
            get: function () { return this._currentView; },
            set: function (value) {
                var viewChangedResult = this._currentView !== value ? value : null;
                this._currentView = value;
                this._moveFocusOnNextTick = true;
                this._changeDetectorRef.markForCheck();
                if (viewChangedResult) {
                    this.viewChanged.emit(viewChangedResult);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerCalendar.prototype, "activeDate", {
            get: function () { return this._clampedActiveDate; },
            set: function (value) {
                this._clampedActiveDate = this._dateAdapter.clampDate(value, this.minDate, this.maxDate);
                this.stateChanges.next();
                this._changeDetectorRef.markForCheck();
            },
            enumerable: false,
            configurable: true
        });
        NtDatePickerCalendar.prototype.ngAfterContentInit = function () {
            this.activeDate = this.startAt || this._dateAdapter.today();
            this._currentView = this.startView;
        };
        NtDatePickerCalendar.prototype.ngOnChanges = function (changes) {
            var change = changes['minDate'] || changes['maxDate'] || changes['dateFilter'];
            if (change && !change.firstChange) {
                var view = this._getCurrentViewComponent();
                if (view) {
                    this._changeDetectorRef.detectChanges();
                    view._init();
                }
            }
            this.stateChanges.next();
        };
        NtDatePickerCalendar.prototype.ngAfterViewChecked = function () {
            if (this._moveFocusOnNextTick) {
                this._moveFocusOnNextTick = false;
                this.focusActiveCell();
            }
        };
        NtDatePickerCalendar.prototype.ngOnDestroy = function () {
            this.stateChanges.complete();
        };
        NtDatePickerCalendar.prototype.focusActiveCell = function () {
            this._getCurrentViewComponent()._focusActiveCell(false);
        };
        NtDatePickerCalendar.prototype.updateTodaysDate = function () {
            var currentView = this.currentView;
            var view;
            if (currentView === 'month') {
                view = this.monthView;
            }
            else if (currentView === 'year') {
                view = this.yearView;
            }
            else {
                view = this.multiYearView;
            }
            view._init();
        };
        NtDatePickerCalendar.prototype._dateSelected = function (event) {
            var date = event.value;
            if (this.selected instanceof DateRange ||
                (date && !this._dateAdapter.sameDate(date, this.selected))) {
                this.selectedChange.emit(date);
            }
            this._userSelection.emit(event);
        };
        NtDatePickerCalendar.prototype._yearSelectedInMultiYearView = function (normalizedYear) {
            this.yearSelected.emit(normalizedYear);
        };
        NtDatePickerCalendar.prototype._monthSelectedInYearView = function (normalizedMonth) {
            this.monthSelected.emit(normalizedMonth);
        };
        NtDatePickerCalendar.prototype._goToDateInView = function (date, view) {
            this.activeDate = date;
            this.currentView = view;
        };
        NtDatePickerCalendar.prototype._getCurrentViewComponent = function () {
            return this.monthView || this.yearView || this.multiYearView;
        };
        return NtDatePickerCalendar;
    }());
    NtDatePickerCalendar.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-datepicker-calendar',
                    template: "<nt-calendar-header></nt-calendar-header>\n\n<ng-container [ngSwitch]=\"currentView\">\n  <nt-calendar-month\n    *ngSwitchCase=\"'month'\"\n    [(activeDate)]=\"activeDate\"\n    [selected]=\"selected\"\n    [dateFilter]=\"dateFilter\"\n    [maxDate]=\"maxDate\"\n    [minDate]=\"minDate\"\n    [dateClass]=\"dateClass\"\n    [comparisonStart]=\"comparisonStart\"\n    [comparisonEnd]=\"comparisonEnd\"\n    (_userSelection)=\"_dateSelected($event)\">\n  </nt-calendar-month>\n  <nt-calendar-year\n    *ngSwitchCase=\"'year'\"\n    [(activeDate)]=\"activeDate\"\n    [selected]=\"selected\"\n    [dateFilter]=\"dateFilter\"\n    [maxDate]=\"maxDate\"\n    [minDate]=\"minDate\"\n    [dateClass]=\"dateClass\"\n    (monthSelected)=\"_monthSelectedInYearView($event)\"\n    (selectedChange)=\"_goToDateInView($event, 'month')\">\n  </nt-calendar-year>\n  <nt-calendar-multi-year\n    *ngSwitchCase=\"'multi-year'\"\n    [(activeDate)]=\"activeDate\"\n    [selected]=\"selected\"\n    [dateFilter]=\"dateFilter\"\n    [maxDate]=\"maxDate\"\n    [minDate]=\"minDate\"\n    [dateClass]=\"dateClass\"\n    (yearSelected)=\"_yearSelectedInMultiYearView($event)\"\n    (selectedChange)=\"_goToDateInView($event, 'year')\">\n  </nt-calendar-multi-year>\n</ng-container>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-datepicker-calendar'
                    }
                },] }
    ];
    NtDatePickerCalendar.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter, decorators: [{ type: core.Optional }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] }
    ]; };
    NtDatePickerCalendar.propDecorators = {
        startView: [{ type: core.Input }],
        startAt: [{ type: core.Input }],
        selected: [{ type: core.Input }, { type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        comparisonStart: [{ type: core.Input }],
        comparisonEnd: [{ type: core.Input }],
        selectedChange: [{ type: core.Output }],
        yearSelected: [{ type: core.Output }],
        monthSelected: [{ type: core.Output }],
        viewChanged: [{ type: core.Output }],
        _userSelection: [{ type: core.Output }],
        monthView: [{ type: core.ViewChild, args: [NtCalendarMonth,] }],
        yearView: [{ type: core.ViewChild, args: [NtCalendarYear,] }],
        multiYearView: [{ type: core.ViewChild, args: [NtCalendarMultiYear,] }]
    };

    var NtCalendarHeader = /** @class */ (function () {
        function NtCalendarHeader(calendar, _dateAdapter, _dateFormats, changeDetectorRef) {
            this.calendar = calendar;
            this._dateAdapter = _dateAdapter;
            this._dateFormats = _dateFormats;
            this.calendar.stateChanges.subscribe(function () { return changeDetectorRef.markForCheck(); });
        }
        Object.defineProperty(NtCalendarHeader.prototype, "_monthLabel", {
            get: function () {
                return this._dateAdapter.format(this.calendar.activeDate, this._dateFormats.display.monthLabel).toLocaleUpperCase();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarHeader.prototype, "_yearLabel", {
            get: function () {
                return this._dateAdapter.getYearName(this.calendar.activeDate);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtCalendarHeader.prototype, "_multiYearLabel", {
            get: function () {
                var activeYear = this._dateAdapter.getYear(this.calendar.activeDate);
                var firstYearInView = this._dateAdapter.getYearName(this._dateAdapter.createDate(activeYear - activeYear % yearsPerPage, 0, 1), 'en-US');
                var lastYearInView = this._dateAdapter.getYearName(this._dateAdapter.createDate(activeYear + yearsPerPage - 1 - activeYear % yearsPerPage, 0, 1), 'en-US');
                return firstYearInView + " \u2013 " + lastYearInView;
            },
            enumerable: false,
            configurable: true
        });
        NtCalendarHeader.prototype.currentPeriodClicked = function () {
            this.calendar.currentView = this.calendar.currentView == 'month' ? 'multi-year' : 'month';
        };
        NtCalendarHeader.prototype.prevMonth = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarMonths(this.calendar.activeDate, -1);
        };
        NtCalendarHeader.prototype.nextMonth = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarMonths(this.calendar.activeDate, 1);
        };
        NtCalendarHeader.prototype.prevYear = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarYears(this.calendar.activeDate, -1);
        };
        NtCalendarHeader.prototype.nextYear = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarYears(this.calendar.activeDate, 1);
        };
        NtCalendarHeader.prototype.prevYearArray = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarYears(this.calendar.activeDate, -yearsPerPage);
        };
        NtCalendarHeader.prototype.nextYearArray = function () {
            this.calendar.activeDate = this._dateAdapter.addCalendarYears(this.calendar.activeDate, yearsPerPage);
        };
        NtCalendarHeader.prototype.previousEnabled = function (viewType) {
            if (viewType === void 0) { viewType = 'month'; }
            if (!this.calendar.minDate) {
                return true;
            }
            return !this.calendar.minDate ||
                !this._isSameView(this.calendar.activeDate, this.calendar.minDate, viewType);
        };
        NtCalendarHeader.prototype.nextEnabled = function (viewType) {
            if (viewType === void 0) { viewType = 'month'; }
            return !this.calendar.maxDate ||
                !this._isSameView(this.calendar.activeDate, this.calendar.maxDate, viewType);
        };
        NtCalendarHeader.prototype.changeCurrentView = function (viewType) {
            this.calendar.currentView = viewType;
        };
        NtCalendarHeader.prototype._isSameView = function (date1, date2, viewType) {
            if (viewType === void 0) { viewType = 'month'; }
            if (viewType == 'month') {
                return this._dateAdapter.getYear(date1) == this._dateAdapter.getYear(date2) &&
                    this._dateAdapter.getMonth(date1) == this._dateAdapter.getMonth(date2);
            }
            if (viewType == 'year') {
                return this._dateAdapter.getYear(date1) == this._dateAdapter.getYear(date2);
            }
            return isSameMultiYearView(this._dateAdapter, date1, date2, this.calendar.minDate, this.calendar.maxDate);
        };
        return NtCalendarHeader;
    }());
    NtCalendarHeader.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-calendar-header',
                    template: "<ng-container [ngSwitch]=\"calendar.currentView\">\n  <table>\n    <thead>\n      <tr *ngSwitchCase=\"'month'\"><ng-container *ngTemplateOutlet=\"monthControl\"></ng-container></tr>\n      <tr *ngSwitchCase=\"'year'\"><ng-container *ngTemplateOutlet=\"yearControl\"></ng-container></tr>\n      <tr *ngSwitchCase=\"'multi-year'\"><ng-container *ngTemplateOutlet=\"multiYearControl\"></ng-container></tr>\n    </thead>\n  </table>\n\n  <ng-template #monthControl>\n    <th (click)=\"prevYear()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!previousEnabled('year')\">\n      <span>&laquo;</span>\n    </th>\n    <th (click)=\"prevMonth()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!previousEnabled()\">\n      <span>&lsaquo;</span>\n    </th>\n    <th colspan=\"3\" class=\"nt-calendar-cell\">\n      <span (click)=\" calendar.currentView = 'multi-year' \">{{ _yearLabel }}</span>\n      <span (click)=\" calendar.currentView = 'year' \">{{ _monthLabel }}</span>\n    </th>\n    <th (click)=\"nextMonth()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!nextEnabled()\">\n      <span>&rsaquo;</span>\n    </th>\n    <th (click)=\"nextYear()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!nextEnabled('year')\">\n      <span>&raquo;</span>\n    </th>\n  </ng-template>\n\n  <ng-template #yearControl>\n    <th (click)=\"prevYear()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!previousEnabled('year')\">\n      <span>&laquo;</span>\n    </th>\n    <th>&nbsp;</th>\n    <th class=\"nt-calendar-cell\" colspan=\"3\">\n      <span (click)=\" calendar.currentView = 'multi-year' \">\n        {{ _yearLabel }}\n      </span>\n    </th>\n    <th>&nbsp;</th>\n    <th (click)=\"nextYear()\"\n      class=\"nt-calendar-cell\"\n      [class.nt-calendar-cell-disabled]=\"!nextEnabled('year')\">\n      <span>&raquo;</span>\n    </th>\n  </ng-template>\n\n  <ng-template #multiYearControl>\n    <th (click)=\"prevYearArray()\" class=\"nt-calendar-cell\">\n      <span>&laquo;</span>\n    </th>\n    <th class=\"nt-calendar-cell\">&nbsp;</th>\n    <th class=\"nt-calendar-cell\" colspan=\"3\">{{_multiYearLabel}}</th>\n    <th>&nbsp;</th>\n    <th (click)=\"nextYearArray()\" class=\"nt-calendar-cell\">\n      <span>&raquo;</span>\n    </th>\n  </ng-template>\n\n</ng-container>\n",
                    exportAs: 'ntCalendarHeader',
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-calendar-header'
                    }
                },] }
    ];
    NtCalendarHeader.ctorParameters = function () { return [
        { type: NtDatePickerCalendar, decorators: [{ type: core.Inject, args: [core.forwardRef(function () { return NtDatePickerCalendar; }),] }] },
        { type: core$1.DateAdapter, decorators: [{ type: core.Optional }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] },
        { type: core.ChangeDetectorRef }
    ]; };

    var NtDatePickerInputBase = /** @class */ (function () {
        function NtDatePickerInputBase(_dateAdapter) {
            var _this = this;
            this._dateAdapter = _dateAdapter;
            this._disabled = false;
            this._required = false;
            this._lastValueValid = false;
            this._onChange = function () { };
            this._onTouched = function () { };
            this._validatorOnChange = function () { };
            this.stateChanges = new rxjs.Subject();
            this._valueChangesSubscription = rxjs.Subscription.EMPTY;
            this._localeSubscription = rxjs.Subscription.EMPTY;
            this._parseValidator = function () {
                return _this._lastValueValid ?
                    null : { 'ntDatePickerParse': { 'text': _this.value } };
            };
            this._filterValidator = function (control) {
                var controlValue = _this._dateAdapter.getValidDateOrNull(_this._dateAdapter.deserialize(control.value));
                var dateFilter = _this._getDateFilter();
                return !dateFilter || !controlValue || dateFilter(controlValue)
                    ? null
                    : { ntDatePickerFilter: true };
            };
            this._minValidator = function (control) {
                var controlValue = _this._dateAdapter.getValidDateOrNull(_this._dateAdapter.deserialize(control.value));
                var min = _this._getMinDate();
                return !min ||
                    !controlValue ||
                    _this._dateAdapter.compareDate(min, controlValue) <= 0
                    ? null
                    : { ntDatePickerMin: { min: min, actual: controlValue } };
            };
            this._maxValidator = function (control) {
                var controlValue = _this._dateAdapter.getValidDateOrNull(_this._dateAdapter.deserialize(control.value));
                var max = _this._getMaxDate();
                return !max ||
                    !controlValue ||
                    _this._dateAdapter.compareDate(max, controlValue) >= 0
                    ? null
                    : { ntDatePickerMax: { max: max, actual: controlValue } };
            };
            this._localeSubscription = _dateAdapter.localeChanges.subscribe(function () {
                _this.value = _this.value;
            });
        }
        Object.defineProperty(NtDatePickerInputBase.prototype, "value", {
            get: function () {
                return this._model
                    ? this._getValueFromModel(this._model.selection)
                    : this._value;
            },
            set: function (value) {
                value = this._dateAdapter.deserialize(value);
                this._lastValueValid = this._isValidValue(value);
                value = this._dateAdapter.getValidDateOrNull(value);
                var oldDate = this.value;
                this._assignValue(value);
                if (!this._dateAdapter.sameDate(oldDate, value)) {
                    this._valueChange(value);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerInputBase.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) {
                this._disabled = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerInputBase.prototype, "required", {
            get: function () {
                var _a, _b;
                if ((_b = (_a = this.ngControl) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.validator) {
                    var control = new forms.FormControl();
                    var validateResult = this.ngControl.control.validator(control);
                    return Object.prototype.hasOwnProperty.call(validateResult, 'required');
                }
                return this._required;
            },
            set: function (value) {
                this._required = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        NtDatePickerInputBase.prototype.ngOnInit = function () { };
        NtDatePickerInputBase.prototype.ngOnDestroy = function () {
            this._valueChangesSubscription.unsubscribe();
            this._localeSubscription.unsubscribe();
            this.stateChanges.complete();
        };
        NtDatePickerInputBase.prototype.writeValue = function (value) {
            this.value = value;
        };
        NtDatePickerInputBase.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NtDatePickerInputBase.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NtDatePickerInputBase.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        NtDatePickerInputBase.prototype.registerOnValidatorChange = function (fn) {
            this._validatorOnChange = fn;
        };
        NtDatePickerInputBase.prototype.validate = function (c) {
            return this._validator ? this._validator(c) : null;
        };
        NtDatePickerInputBase.prototype._valueChange = function (value) {
            this._onChange(value);
        };
        NtDatePickerInputBase.prototype._registerModel = function (model) {
            var _this = this;
            this._model = model;
            this._valueChangesSubscription.unsubscribe();
            if (this._value) {
                this._assignValue(this._value);
            }
            this._valueChangesSubscription = this._model.selectionChanged.subscribe(function (event) {
                if (event.source !== _this) {
                    var value = _this._getValueFromModel(event.selection);
                    _this._lastValueValid = _this._isValidValue(value);
                    _this._valueChange(value);
                    _this._onTouched();
                }
            });
        };
        NtDatePickerInputBase.prototype._assignValue = function (value) {
            if (this._model) {
                this._assignValueToModel(value);
                this._value = null;
            }
            else {
                this._value = value;
            }
        };
        NtDatePickerInputBase.prototype._isValidValue = function (value) {
            return !value || this._dateAdapter.isValid(value);
        };
        NtDatePickerInputBase.prototype._getValidators = function () {
            return [
                this._parseValidator,
                this._minValidator,
                this._maxValidator,
                this._filterValidator,
            ];
        };
        return NtDatePickerInputBase;
    }());
    NtDatePickerInputBase.decorators = [
        { type: core.Directive }
    ];
    NtDatePickerInputBase.ctorParameters = function () { return [
        { type: core$1.DateAdapter }
    ]; };
    NtDatePickerInputBase.propDecorators = {
        disabled: [{ type: core.Input }],
        required: [{ type: core.Input }]
    };

    var NT_DATE_RANGE_PICKER_PARENT = new core.InjectionToken('nt-date-range-parent');
    var NtDateRangePart = /** @class */ (function (_super) {
        __extends(NtDateRangePart, _super);
        function NtDateRangePart(dateAdapter, _rangePicker, _injector) {
            var _this = _super.call(this, dateAdapter) || this;
            _this._rangePicker = _rangePicker;
            _this._injector = _injector;
            return _this;
        }
        NtDateRangePart.prototype.ngOnInit = function () {
            var ngControl = this._injector.get(forms.NgControl, null, core.InjectFlags.Self);
            if (ngControl) {
                this.ngControl = ngControl;
            }
        };
        NtDateRangePart.prototype._getMinDate = function () {
            return this._rangePicker.min;
        };
        NtDateRangePart.prototype._getMaxDate = function () {
            return this._rangePicker.max;
        };
        NtDateRangePart.prototype._getDateFilter = function () {
            return this._rangePicker.dateFilter;
        };
        return NtDateRangePart;
    }(NtDatePickerInputBase));
    NtDateRangePart.decorators = [
        { type: core.Directive }
    ];
    NtDateRangePart.ctorParameters = function () { return [
        { type: core$1.DateAdapter },
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_DATE_RANGE_PICKER_PARENT,] }] },
        { type: core.Injector }
    ]; };
    var NtDateRangeStart = /** @class */ (function (_super) {
        __extends(NtDateRangeStart, _super);
        function NtDateRangeStart() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._startValidator = function (control) {
                var start = _this._dateAdapter.getValidDateOrNull(_this._dateAdapter.deserialize(control.value));
                var end = _this._model ? _this._model.selection.end : null;
                return (!start || !end ||
                    _this._dateAdapter.compareDate(start, end) <= 0) ?
                    null : { 'ntDateRangeStartInvalid': { 'end': end, 'actual': start } };
            };
            _this._validator = forms.Validators.compose(__spread(_super.prototype._getValidators.call(_this), [_this._startValidator]));
            return _this;
        }
        NtDateRangeStart.prototype._assignValueToModel = function (value) {
            if (this._model) {
                var range = new DateRange(value, this._model.selection.end);
                this._model.updateSelection(range, this);
                this._valueChange(value);
            }
        };
        NtDateRangeStart.prototype._getValueFromModel = function (modelValue) {
            return modelValue.start;
        };
        return NtDateRangeStart;
    }(NtDateRangePart));
    NtDateRangeStart.decorators = [
        { type: core.Directive, args: [{
                    selector: 'nt-date-range-start',
                    providers: [
                        { provide: forms.NG_VALUE_ACCESSOR, useExisting: NtDateRangeStart, multi: true },
                        { provide: forms.NG_VALIDATORS, useExisting: NtDateRangeStart, multi: true }
                    ],
                },] }
    ];
    var NtDateRangeEnd = /** @class */ (function (_super) {
        __extends(NtDateRangeEnd, _super);
        function NtDateRangeEnd() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._endValidator = function (control) {
                var end = _this._dateAdapter.getValidDateOrNull(_this._dateAdapter.deserialize(control.value));
                var start = _this._model ? _this._model.selection.start : null;
                return (!end || !start ||
                    _this._dateAdapter.compareDate(end, start) >= 0) ?
                    null : { 'ntDateRangeEndInvalid': { 'start': start, 'actual': end } };
            };
            _this._validator = forms.Validators.compose(__spread(_super.prototype._getValidators.call(_this), [_this._endValidator]));
            return _this;
        }
        NtDateRangeEnd.prototype._assignValueToModel = function (value) {
            if (this._model) {
                var range = new DateRange(this._model.selection.start, value);
                this._model.updateSelection(range, this);
                this._valueChange(value);
            }
        };
        NtDateRangeEnd.prototype._getValueFromModel = function (modelValue) {
            return modelValue.end;
        };
        return NtDateRangeEnd;
    }(NtDateRangePart));
    NtDateRangeEnd.decorators = [
        { type: core.Directive, args: [{
                    selector: 'nt-date-range-end',
                    providers: [
                        { provide: forms.NG_VALUE_ACCESSOR, useExisting: NtDateRangeEnd, multi: true },
                        { provide: forms.NG_VALIDATORS, useExisting: NtDateRangeEnd, multi: true }
                    ],
                },] }
    ];

    var NT_DATE_PICKER_CONTROL = new core.InjectionToken('nt-datepicker-control');

    var NtDatePickerContent = /** @class */ (function () {
        function NtDatePickerContent(elementRef, _changeDetectorRef, _model, _dateAdapter, _rangeSelectionStrategy, datepicker) {
            this.elementRef = elementRef;
            this._changeDetectorRef = _changeDetectorRef;
            this._model = _model;
            this._dateAdapter = _dateAdapter;
            this._rangeSelectionStrategy = _rangeSelectionStrategy;
            this.datepicker = datepicker;
            this._subscriptions = new rxjs.Subscription();
        }
        NtDatePickerContent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this._subscriptions.add(this.datepicker._stateChanges.subscribe(function () {
                _this._changeDetectorRef.markForCheck();
            }));
            this._calendar.focusActiveCell();
        };
        NtDatePickerContent.prototype.ngOnDestroy = function () {
            this._subscriptions.unsubscribe();
        };
        NtDatePickerContent.prototype._handleUserSelection = function (event) {
            var selection = this._model.selection;
            var value = event.value;
            var isRange = selection instanceof DateRange;
            if (isRange && this._rangeSelectionStrategy) {
                var newSelection = this._rangeSelectionStrategy.selectionFinished(value, selection, event.event);
                this._model.updateSelection(newSelection, this);
            }
            else if (value && (isRange ||
                !this._dateAdapter.sameDate(value, selection))) {
                this._model.add(value);
            }
            if (!this._model || this._model.isComplete()) {
                this.datepicker.overlay.close();
            }
        };
        NtDatePickerContent.prototype._getSelected = function () {
            return this._model.selection;
        };
        return NtDatePickerContent;
    }());
    NtDatePickerContent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-datepicker-content',
                    template: "<div cdkTrapFocus>\n  <nt-datepicker-calendar\n    [id]=\"datepicker.id\"\n    [startAt]=\"datepicker.startAt\"\n    [minDate]=\"datepicker.min\"\n    [maxDate]=\"datepicker.max\"\n    [dateFilter]=\"datepicker.dateFilter\"\n    [selected]=\"_getSelected()\"\n    [dateClass]=\"datepicker.dateClass\"\n    [comparisonStart]=\"comparisonStart\"\n    [comparisonEnd]=\"comparisonEnd\"\n    (_userSelection)=\"_handleUserSelection($event)\">\n  </nt-datepicker-calendar>\n</div>\n",
                    host: {
                        'class': 'nt-datepicker-content',
                    },
                    exportAs: 'ntDatepickerContent',
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NtDatePickerContent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef },
        { type: NtDateSelectionModel },
        { type: core$1.DateAdapter },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_DATE_RANGE_SELECTION_STRATEGY,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_DATE_PICKER_CONTROL,] }] }
    ]; };
    NtDatePickerContent.propDecorators = {
        _calendar: [{ type: core.ViewChild, args: [NtDatePickerCalendar,] }]
    };

    var DEFAULT_DATEPICKER_ICONS = {
        caret: 'far fa-calendar-alt',
        clear: 'fa fa-times'
    };
    var NT_DATEPICKER_ICONS = new core.InjectionToken('nt-datepicker-icons');

    var NtDatePickerBase = /** @class */ (function () {
        function NtDatePickerBase(elementRef, tabIndex, icons, _dateFormats, _changeDetectorRef, _dateAdapter, _model) {
            var _this = this;
            this.icons = icons;
            this._dateFormats = _dateFormats;
            this._changeDetectorRef = _changeDetectorRef;
            this._dateAdapter = _dateAdapter;
            this._model = _model;
            this._overlayToggle = new rxjs.Subject();
            this._positionPairs = [overlay.BOTTOM_LEFT, overlay.TOP_LEFT];
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this._stateChanges = new rxjs.Subject();
            this.origin = new overlay$1.CdkOverlayOrigin(elementRef);
            this.icons = Object.assign(Object.assign({}, DEFAULT_DATEPICKER_ICONS), icons);
            this.tabIndex = parseInt(tabIndex) || 0;
            this._overlayToggle.pipe(operators.debounceTime(10)).subscribe(function (open) { return open
                ? _this.overlay.open()
                : _this.overlay.toggle(); });
            this._model.selectionChanged.subscribe(function (value) {
                _this._formatValue(value.selection);
            });
        }
        Object.defineProperty(NtDatePickerBase.prototype, "startAt", {
            get: function () { return this._startAt || this._getStartValue(); },
            set: function (value) {
                this._startAt = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerBase.prototype, "min", {
            get: function () { return this._min; },
            set: function (value) {
                this._min = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePickerBase.prototype, "max", {
            get: function () { return this._max; },
            set: function (value) {
                this._max = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value));
            },
            enumerable: false,
            configurable: true
        });
        NtDatePickerBase.prototype.ngAfterViewInit = function () {
            this._changeDetectorRef.markForCheck();
        };
        NtDatePickerBase.prototype.ngOnChanges = function (changes) {
            var change = changes.value || changes.startAt || changes.minDate || changes.maxDate;
            if (change && !change.firstChange) {
                this._changeDetectorRef.markForCheck();
            }
            this._stateChanges.next(undefined);
        };
        NtDatePickerBase.prototype.ngOnDestroy = function () {
            this._stateChanges.complete();
        };
        NtDatePickerBase.prototype.focus = function () {
            this.overlay.open();
        };
        NtDatePickerBase.prototype.select = function (date) {
            this._model.add(date);
        };
        NtDatePickerBase.prototype._onAfterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtDatePickerBase.prototype._onAfterClosed = function (event) {
            this.afterClosed.next(event);
            this._portal.detach();
        };
        NtDatePickerBase.prototype._onBeforeOpen = function (event) {
            this._portal = new portal.ComponentPortal(NtDatePickerContent);
            this.beforeOpen.next(event);
        };
        NtDatePickerBase.prototype._onBeforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtDatePickerBase.prototype._onPositionChange = function (change) {
            this.positionChange.next(change);
        };
        NtDatePickerBase.prototype._onClick = function (event) {
            if (this._isActivated()) {
                this.overlay.toggle();
            }
            event.stopPropagation();
        };
        NtDatePickerBase.prototype._onClear = function (event) {
            if (this._isActivated()) {
                this._model.updateSelection(this._getDefaultModelValue(), this);
            }
            event.stopPropagation();
        };
        return NtDatePickerBase;
    }());
    NtDatePickerBase.decorators = [
        { type: core.Directive }
    ];
    NtDatePickerBase.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: String, decorators: [{ type: core.Attribute, args: ['tabindex',] }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_DATEPICKER_ICONS,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] },
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter },
        { type: NtDateSelectionModel }
    ]; };
    NtDatePickerBase.propDecorators = {
        startAt: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        afterOpen: [{ type: core.Output }],
        afterClosed: [{ type: core.Output }],
        beforeOpen: [{ type: core.Output }],
        beforeClosed: [{ type: core.Output }],
        positionChange: [{ type: core.Output }],
        overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }],
        _portalOutlet: [{ type: core.ViewChild, args: [portal.CdkPortalOutlet, { static: true },] }]
    };

    var datepickerUid = 0;
    var NtDateRangePicker = /** @class */ (function (_super) {
        __extends(NtDateRangePicker, _super);
        function NtDateRangePicker(elementRef, tabIndex, icons, dateFormats, changeDetectorRef, dateAdapter, model, control) {
            var _this = _super.call(this, elementRef, tabIndex, icons, dateFormats, changeDetectorRef, dateAdapter, model) || this;
            _this.id = "nt-date-range-picker-" + datepickerUid++;
            _this._displayValue = '';
            _this._placeholder = '';
            _this._disabled = false;
            _this._required = false;
            _this._readonly = false;
            _this.ngControl = control;
            return _this;
        }
        Object.defineProperty(NtDateRangePicker.prototype, "placeholder", {
            get: function () { return this._placeholder; },
            set: function (value) {
                this._placeholder = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDateRangePicker.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) {
                this._disabled = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDateRangePicker.prototype, "required", {
            get: function () { return this._startDate.required || this._endDate.required || this._required; },
            set: function (value) {
                this._required = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDateRangePicker.prototype, "readonly", {
            get: function () { return this._readonly; },
            set: function (value) {
                this._readonly = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        NtDateRangePicker.prototype.ngAfterContentInit = function () {
            this._startDate._registerModel(this._model);
            this._endDate._registerModel(this._model);
        };
        NtDateRangePicker.prototype._isActivated = function () {
            return !this.disabled;
        };
        NtDateRangePicker.prototype._getStartValue = function () {
            var _a, _b;
            return ((_a = this._startDate) === null || _a === void 0 ? void 0 : _a.value) || ((_b = this._endDate) === null || _b === void 0 ? void 0 : _b.value);
        };
        NtDateRangePicker.prototype.getErrors = function () {
            var _a, _b;
            return Object.assign(Object.assign({}, (_a = this._startDate.ngControl) === null || _a === void 0 ? void 0 : _a.errors), (_b = this._endDate.ngControl) === null || _b === void 0 ? void 0 : _b.errors);
        };
        NtDateRangePicker.prototype._getValueFromModel = function (modelValue) {
            return modelValue.start;
        };
        NtDateRangePicker.prototype._formatValue = function (modelValue) {
            var startValue = this._formatPartValue(modelValue.start);
            var endValue = this._formatPartValue(modelValue.end);
            if (startValue || endValue) {
                this._displayValue = this._formatPartValue(modelValue.start) + " - " + this._formatPartValue(modelValue.end);
            }
            else {
                this._displayValue = '';
            }
        };
        NtDateRangePicker.prototype._getDefaultModelValue = function () {
            return new DateRange(null, null);
        };
        NtDateRangePicker.prototype._formatPartValue = function (value) {
            return value ? this._dateAdapter.format(value, this._dateFormats.display.dateInput) : '';
        };
        return NtDateRangePicker;
    }(NtDatePickerBase));
    NtDateRangePicker.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-date-range-picker',
                    template: "\n<nt-pseudo-input\n  [style.margin.px]=\"0\"\n  [attr.tabindex]=\"tabIndex\"\n  [value]=\"_displayValue\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"disabled\">\n  <nt-pseudo-caret *ngIf=\"!_displayValue || disabled\">\n    <span [class]=\"icons.caret\"></span>\n  </nt-pseudo-caret>\n  <nt-pseudo-caret class=\"nt-datepicker-clear\" (click)=\"_onClear($event)\" *ngIf=\"_displayValue && !disabled\">\n    <span [class]=\"icons.clear\"></span>\n  </nt-pseudo-caret>\n</nt-pseudo-input>\n\n<nt-overlay\n  overlayClass=\"nt-datepicker-overlay\"\n  [origin]=\"origin\"\n  [positionPairs]=\"_positionPairs\"\n  arrow\n  (afterOpen)=\"_onAfterOpen($event)\"\n  (afterClosed)=\"_onAfterClosed($event)\"\n  (beforeOpen)=\"_onBeforeOpen($event)\"\n  (beforeClosed)=\"_onBeforeClosed($event)\"\n  (positionChange)=\"_onPositionChange($event)\">\n  <div class=\"nt-datepicker-pane\">\n    <ng-template [cdkPortalOutlet]=\"_portal\"></ng-template>\n  </div>\n</nt-overlay>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-datepicker nt-date-range-picker',
                        '(click)': '_onClick($event)',
                    },
                    animations: [
                        animations.trigger('fade', [
                            animations.transition('* => void', core$1.fadeOut(.15)),
                            animations.transition('void => *', core$1.fadeIn(.15))
                        ])
                    ],
                    providers: [
                        { provide: forms$1.NtFormFieldControl, useExisting: NtDateRangePicker },
                        { provide: NT_DATE_PICKER_CONTROL, useExisting: NtDateRangePicker },
                        { provide: NT_DATE_RANGE_PICKER_PARENT, useExisting: NtDateRangePicker },
                        NT_RANGE_DATE_SELECTION_MODEL_PROVIDER,
                        NT_CALENDAR_RANGE_STRATEGY_PROVIDER
                    ]
                },] }
    ];
    NtDateRangePicker.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: String, decorators: [{ type: core.Attribute, args: ['tabindex',] }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_DATEPICKER_ICONS,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] },
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter },
        { type: NtDateSelectionModel },
        { type: forms.ControlContainer, decorators: [{ type: core.Optional }, { type: core.Self }] }
    ]; };
    NtDateRangePicker.propDecorators = {
        placeholder: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        required: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        _startDate: [{ type: core.ContentChild, args: [NtDateRangeStart,] }],
        _endDate: [{ type: core.ContentChild, args: [NtDateRangeEnd,] }]
    };

    var datepickerUid$1 = 0;
    var NtDatePicker = /** @class */ (function (_super) {
        __extends(NtDatePicker, _super);
        function NtDatePicker(_elementRef, tabIndex, icons, _dateFormats, _changeDetectorRef, dateAdapter, _model, ngControl) {
            var _this = _super.call(this, dateAdapter) || this;
            _this._elementRef = _elementRef;
            _this.icons = icons;
            _this._dateFormats = _dateFormats;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.ngControl = ngControl;
            _this._overlayToggle = new rxjs.Subject();
            _this._displayValue = '';
            _this.id = "nt-datepicker-" + datepickerUid$1++;
            _this._positionPairs = [overlay.BOTTOM_LEFT, overlay.TOP_LEFT];
            _this._placeholder = '';
            _this._readonly = false;
            _this.afterOpen = new core.EventEmitter();
            _this.afterClosed = new core.EventEmitter();
            _this.beforeOpen = new core.EventEmitter();
            _this.beforeClosed = new core.EventEmitter();
            _this.positionChange = new core.EventEmitter();
            _this._stateChanges = new rxjs.Subject();
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            _this._registerModel(_model);
            _this.origin = new overlay$1.CdkOverlayOrigin(_elementRef);
            _this.icons = Object.assign(Object.assign({}, DEFAULT_DATEPICKER_ICONS), icons);
            _this.tabIndex = parseInt(tabIndex) || 0;
            _this._overlayToggle.pipe(operators.debounceTime(10)).subscribe(function (open) { return open
                ? _this.overlay.open()
                : _this.overlay.toggle(); });
            _this._model.selectionChanged.subscribe(function (value) {
                _this._formatValue(value.selection);
            });
            return _this;
        }
        Object.defineProperty(NtDatePicker.prototype, "startAt", {
            get: function () { return this._startAt || this._getStartValue(); },
            set: function (value) { this._startAt = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePicker.prototype, "min", {
            get: function () { return this._min; },
            set: function (value) { this._min = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePicker.prototype, "max", {
            get: function () { return this._max; },
            set: function (value) { this._max = this._dateAdapter.getValidDateOrNull(this._dateAdapter.deserialize(value)); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePicker.prototype, "placeholder", {
            get: function () { return this._placeholder; },
            set: function (value) { this._placeholder = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDatePicker.prototype, "readonly", {
            get: function () { return this._readonly; },
            set: function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        NtDatePicker.prototype.getErrors = function () {
            var _a;
            return (_a = this.ngControl) === null || _a === void 0 ? void 0 : _a.errors;
        };
        NtDatePicker.prototype._isActivated = function () {
            return !this.disabled;
        };
        NtDatePicker.prototype.ngAfterViewInit = function () {
            this._changeDetectorRef.markForCheck();
        };
        NtDatePicker.prototype.ngOnChanges = function (changes) {
            var change = changes.value || changes.startAt || changes.minDate || changes.maxDate;
            if (change && !change.firstChange) {
                this._changeDetectorRef.markForCheck();
            }
            this._stateChanges.next(undefined);
        };
        NtDatePicker.prototype.ngOnDestroy = function () {
            this._stateChanges.complete();
        };
        NtDatePicker.prototype.focus = function () {
            this.overlay.open();
        };
        NtDatePicker.prototype.select = function (date) {
            this._model.add(date);
        };
        NtDatePicker.prototype._onAfterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtDatePicker.prototype._onAfterClosed = function (event) {
            this.afterClosed.next(event);
            this._portal.detach();
        };
        NtDatePicker.prototype._onBeforeOpen = function (event) {
            this._portal = new portal.ComponentPortal(NtDatePickerContent);
            this.beforeOpen.next(event);
        };
        NtDatePicker.prototype._onBeforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtDatePicker.prototype._onPositionChange = function (change) {
            this.positionChange.next(change);
        };
        NtDatePicker.prototype._onClick = function (event) {
            if (!this.disabled) {
                this.overlay.toggle();
            }
            event.stopPropagation();
        };
        NtDatePicker.prototype._onClear = function (event) {
            if (!this.disabled) {
                this._model.updateSelection(this._getDefaultModelValue(), this);
            }
            event.stopPropagation();
        };
        NtDatePicker.prototype._assignValueToModel = function (value) {
            if (this._model) {
                value = this._dateAdapter.deserialize(value);
                this._model.updateSelection(value, this);
                this._valueChange(value);
            }
        };
        NtDatePicker.prototype._getValueFromModel = function (modelValue) {
            return modelValue;
        };
        NtDatePicker.prototype._getMinDate = function () {
            return this.min;
        };
        NtDatePicker.prototype._getMaxDate = function () {
            return this.max;
        };
        NtDatePicker.prototype._getDateFilter = function () {
            return this.dateFilter;
        };
        NtDatePicker.prototype._getStartValue = function () { var _a; return (_a = this._model) === null || _a === void 0 ? void 0 : _a.selection; };
        NtDatePicker.prototype._formatValue = function (modelValue) {
            if (modelValue) {
                this._displayValue = this._dateAdapter.format(modelValue, this._dateFormats.display.dateInput);
            }
            else {
                this._displayValue = '';
            }
        };
        NtDatePicker.prototype._getDefaultModelValue = function () {
            return null;
        };
        return NtDatePicker;
    }(NtDatePickerInputBase));
    NtDatePicker.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-datepicker',
                    template: "\n<nt-pseudo-input\n  [style.margin.px]=\"0\"\n  [attr.tabindex]=\"tabIndex\"\n  [value]=\"_displayValue\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"disabled\">\n  <nt-pseudo-caret *ngIf=\"!_displayValue || disabled\">\n    <span [class]=\"icons.caret\"></span>\n  </nt-pseudo-caret>\n  <nt-pseudo-caret class=\"nt-datepicker-clear\" (click)=\"_onClear($event)\" *ngIf=\"_displayValue && !disabled\">\n    <span [class]=\"icons.clear\"></span>\n  </nt-pseudo-caret>\n</nt-pseudo-input>\n\n<nt-overlay\n  overlayClass=\"nt-datepicker-overlay\"\n  [origin]=\"origin\"\n  [positionPairs]=\"_positionPairs\"\n  arrow\n  (afterOpen)=\"_onAfterOpen($event)\"\n  (afterClosed)=\"_onAfterClosed($event)\"\n  (beforeOpen)=\"_onBeforeOpen($event)\"\n  (beforeClosed)=\"_onBeforeClosed($event)\"\n  (positionChange)=\"_onPositionChange($event)\">\n  <div class=\"nt-datepicker-pane\">\n    <ng-template [cdkPortalOutlet]=\"_portal\"></ng-template>\n  </div>\n</nt-overlay>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-datepicker',
                        '(click)': '_onClick($event)',
                    },
                    animations: [
                        animations.trigger('fade', [
                            animations.transition('* => void', core$1.fadeOut(.15)),
                            animations.transition('void => *', core$1.fadeIn(.15))
                        ])
                    ],
                    providers: [
                        { provide: forms$1.NtFormFieldControl, useExisting: NtDatePicker },
                        { provide: NT_DATE_PICKER_CONTROL, useExisting: NtDatePicker },
                        NT_SINGLE_DATE_SELECTION_MODEL_PROVIDER
                    ]
                },] }
    ];
    NtDatePicker.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: String, decorators: [{ type: core.Attribute, args: ['tabindex',] }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_DATEPICKER_ICONS,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [core$1.NT_DATE_FORMATS,] }] },
        { type: core.ChangeDetectorRef },
        { type: core$1.DateAdapter },
        { type: NtDateSelectionModel },
        { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] }
    ]; };
    NtDatePicker.propDecorators = {
        startAt: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        dateClass: [{ type: core.Input }],
        dateFilter: [{ type: core.Input }],
        afterOpen: [{ type: core.Output }],
        afterClosed: [{ type: core.Output }],
        beforeOpen: [{ type: core.Output }],
        beforeClosed: [{ type: core.Output }],
        positionChange: [{ type: core.Output }],
        overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }],
        _portalOutlet: [{ type: core.ViewChild, args: [portal.CdkPortalOutlet, { static: true },] }]
    };

    var NtDatePickerModule = /** @class */ (function () {
        function NtDatePickerModule() {
        }
        return NtDatePickerModule;
    }());
    NtDatePickerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        a11y.A11yModule,
                        portal.PortalModule,
                        overlay.NtOverlayModule,
                        core$1.NtPseudoInputModule,
                    ],
                    exports: [
                        NtDatePicker,
                        NtDateRangePicker,
                        NtDateRangeStart,
                        NtDateRangeEnd
                    ],
                    declarations: [
                        NtDatePicker,
                        NtDatePickerContent,
                        NtDatePickerCalendar,
                        NtCalendarBody,
                        NtCalendarHeader,
                        NtCalendarMonth,
                        NtCalendarYear,
                        NtCalendarMultiYear,
                        NtDateRangePicker,
                        NtDateRangeStart,
                        NtDateRangeEnd
                    ]
                },] }
    ];

    exports.DEFAULT_DATEPICKER_ICONS = DEFAULT_DATEPICKER_ICONS;
    exports.DateRange = DateRange;
    exports.DefaultNtCalendarRangeStrategy = DefaultNtCalendarRangeStrategy;
    exports.MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER = MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER;
    exports.MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY = MONTHLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY;
    exports.MonthlyNtCalendarRangeStrategy = MonthlyNtCalendarRangeStrategy;
    exports.NT_CALENDAR_RANGE_STRATEGY_PROVIDER = NT_CALENDAR_RANGE_STRATEGY_PROVIDER;
    exports.NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY = NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY;
    exports.NT_DATEPICKER_ICONS = NT_DATEPICKER_ICONS;
    exports.NT_DATE_RANGE_PICKER_PARENT = NT_DATE_RANGE_PICKER_PARENT;
    exports.NT_DATE_RANGE_SELECTION_STRATEGY = NT_DATE_RANGE_SELECTION_STRATEGY;
    exports.NT_RANGE_DATE_SELECTION_MODEL_FACTORY = NT_RANGE_DATE_SELECTION_MODEL_FACTORY;
    exports.NT_RANGE_DATE_SELECTION_MODEL_PROVIDER = NT_RANGE_DATE_SELECTION_MODEL_PROVIDER;
    exports.NT_SINGLE_DATE_SELECTION_MODEL_FACTORY = NT_SINGLE_DATE_SELECTION_MODEL_FACTORY;
    exports.NT_SINGLE_DATE_SELECTION_MODEL_PROVIDER = NT_SINGLE_DATE_SELECTION_MODEL_PROVIDER;
    exports.NtCalendarMonth = NtCalendarMonth;
    exports.NtCalendarMultiYear = NtCalendarMultiYear;
    exports.NtCalendarYear = NtCalendarYear;
    exports.NtDatePicker = NtDatePicker;
    exports.NtDatePickerBase = NtDatePickerBase;
    exports.NtDatePickerCalendar = NtDatePickerCalendar;
    exports.NtDatePickerInputBase = NtDatePickerInputBase;
    exports.NtDatePickerModule = NtDatePickerModule;
    exports.NtDateRangeEnd = NtDateRangeEnd;
    exports.NtDateRangePart = NtDateRangePart;
    exports.NtDateRangePicker = NtDateRangePicker;
    exports.NtDateRangeStart = NtDateRangeStart;
    exports.NtDateSelectionModel = NtDateSelectionModel;
    exports.NtRangeDateSelectionModel = NtRangeDateSelectionModel;
    exports.NtSingleDateSelectionModel = NtSingleDateSelectionModel;
    exports.WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER = WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER;
    exports.WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY = WEEKLY_NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY;
    exports.WeeklyNtCalendarRangeStrategy = WeeklyNtCalendarRangeStrategy;
    exports.createMissingDateImplError = createMissingDateImplError;
    exports.ɵb = NT_DATE_PICKER_CONTROL;
    exports.ɵc = NT_SINGLE_DATE_SELECTION_MODEL_PROVIDER;
    exports.ɵd = NtDateSelectionModel;
    exports.ɵe = NtDateSelectionModel;
    exports.ɵf = NT_RANGE_DATE_SELECTION_MODEL_PROVIDER;
    exports.ɵg = NT_CALENDAR_RANGE_STRATEGY_PROVIDER;
    exports.ɵh = NtDatePickerContent;
    exports.ɵi = NtCalendarBody;
    exports.ɵj = NT_DATE_RANGE_SELECTION_STRATEGY;
    exports.ɵl = NtCalendarHeader;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=datepicker.umd.js.map
