(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/platform'), require('@angular/common'), require('@angular/core'), require('@angular/cdk/coercion'), require('@angular/forms'), require('@ng-tangram/components/forms')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/input', ['exports', '@angular/cdk/platform', '@angular/common', '@angular/core', '@angular/cdk/coercion', '@angular/forms', '@ng-tangram/components/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.input = {}), global.ng.cdk.platform, global.ng.common, global.ng.core, global.ng.cdk.coercion, global.ng.forms, global.nt.components.forms));
}(this, (function (exports, platform, common, core, coercion, forms$1, forms) { 'use strict';

    var NtInputAddonComponent = /** @class */ (function () {
        function NtInputAddonComponent() {
        }
        return NtInputAddonComponent;
    }());
    NtInputAddonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-input-addon, [nt-input-addon]',
                    template: "<ng-content></ng-content>",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        'class': 'nt-input-addon input-group-label'
                    }
                },] }
    ];

    var NtInputGroupComponent = /** @class */ (function () {
        function NtInputGroupComponent() {
            this._transparent = false;
        }
        Object.defineProperty(NtInputGroupComponent.prototype, "transparent", {
            get: function () { return this._transparent; },
            set: function (value) {
                this._transparent = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        return NtInputGroupComponent;
    }());
    NtInputGroupComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-input-group, [nt-input-group]',
                    template: "<ng-content></ng-content>",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        'class': 'nt-input-group input-group',
                        '[class.nt-input-group-transparent]': 'transparent'
                    }
                },] }
    ];
    NtInputGroupComponent.propDecorators = {
        transparent: [{ type: core.Input }]
    };

    var NtInputDirective = /** @class */ (function () {
        function NtInputDirective(ngControl, _platform, _elementRef) {
            this.ngControl = ngControl;
            this._platform = _platform;
            this._elementRef = _elementRef;
            this._disabled = false;
            this._type = 'text';
            this._readonly = false;
            this._required = false;
            this._focused = false;
            this.placeholder = '';
        }
        Object.defineProperty(NtInputDirective.prototype, "disabled", {
            get: function () {
                if (this.ngControl && this.ngControl.disabled !== null) {
                    return this.ngControl.disabled;
                }
                return this._disabled;
            },
            set: function (value) {
                this._disabled = coercion.coerceBooleanProperty(value);
                if (this._focused) {
                    this._focused = false;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtInputDirective.prototype, "required", {
            get: function () { return this._required; },
            set: function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtInputDirective.prototype, "type", {
            get: function () { return this._type; },
            set: function (value) {
                this._type = value || 'text';
                if (!this._isTextarea() && platform.getSupportedInputTypes().has(this._type)) {
                    this._elementRef.nativeElement.type = this._type;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtInputDirective.prototype, "value", {
            get: function () { return this._elementRef.nativeElement.value; },
            set: function (value) {
                if (value !== this.value) {
                    this._elementRef.nativeElement.value = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtInputDirective.prototype, "readonly", {
            get: function () { return this._readonly; },
            set: function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtInputDirective.prototype, "empty", {
            get: function () { return !this._elementRef.nativeElement.value && !this._isBadInput(); },
            enumerable: false,
            configurable: true
        });
        NtInputDirective.prototype.focus = function () { this._elementRef.nativeElement.focus(); };
        NtInputDirective.prototype._focusChanged = function (isFocused) {
            if (isFocused !== this._focused && !this.readonly) {
                this._focused = isFocused;
            }
        };
        NtInputDirective.prototype._isBadInput = function () {
            var validity = this._elementRef.nativeElement.validity;
            return validity && validity.badInput;
        };
        NtInputDirective.prototype._isTextarea = function () {
            var nativeElement = this._elementRef.nativeElement;
            var nodeName = this._platform.isBrowser ? nativeElement.nodeName : nativeElement.name;
            return nodeName ? nodeName.toLowerCase() === 'textarea' : false;
        };
        return NtInputDirective;
    }());
    NtInputDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'input[ntInput], textarea[ntInput]',
                    host: {
                        '(blur)': '_focusChanged(false)',
                        '(focus)': '_focusChanged(true)',
                    },
                    providers: [
                        { provide: forms.NtFormFieldControl, useExisting: NtInputDirective }
                    ]
                },] }
    ];
    NtInputDirective.ctorParameters = function () { return [
        { type: forms$1.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
        { type: platform.Platform },
        { type: core.ElementRef }
    ]; };
    NtInputDirective.propDecorators = {
        placeholder: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        required: [{ type: core.Input }],
        type: [{ type: core.Input }],
        value: [{ type: core.Input }],
        readonly: [{ type: core.Input }]
    };

    var NtInputModule = /** @class */ (function () {
        function NtInputModule() {
        }
        return NtInputModule;
    }());
    NtInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtInputDirective, NtInputGroupComponent, NtInputAddonComponent],
                    declarations: [NtInputDirective, NtInputGroupComponent, NtInputAddonComponent],
                    providers: [platform.Platform]
                },] }
    ];

    exports.NtInputAddonComponent = NtInputAddonComponent;
    exports.NtInputDirective = NtInputDirective;
    exports.NtInputGroupComponent = NtInputGroupComponent;
    exports.NtInputModule = NtInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=input.umd.js.map
