import { ElementRef, EventEmitter, NgZone, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
export declare type NtCalendarCellCssClasses = string | string[] | Set<string> | {
    [key: string]: any;
};
export declare type NtCalendarCellClassFunction<D> = (date: D, view: 'month' | 'year' | 'multi-year') => NtCalendarCellCssClasses;
export declare class NtCalendarCell<D = any> {
    value: number;
    displayValue: string;
    enabled: boolean;
    cssClasses: NtCalendarCellCssClasses;
    compareValue: number;
    rawValue?: D | undefined;
    constructor(value: number, displayValue: string, enabled: boolean, cssClasses?: NtCalendarCellCssClasses, compareValue?: number, rawValue?: D | undefined);
}
export interface NtCalendarUserEvent<D> {
    value: D;
    event: Event;
}
export declare class NtCalendarBody implements OnChanges, OnDestroy {
    private _elementRef;
    private _ngZone;
    private _skipNextFocus;
    label: string;
    rows: NtCalendarCell[][];
    todayValue: number;
    startValue: number;
    endValue: number;
    numCols: number;
    activeCell: number;
    isRange: boolean;
    cellAspectRatio: number;
    comparisonStart: number | null;
    comparisonEnd: number | null;
    previewStart: number | null;
    previewEnd: number | null;
    readonly selectedValueChange: EventEmitter<NtCalendarUserEvent<number>>;
    previewChange: EventEmitter<NtCalendarUserEvent<NtCalendarCell<any> | null>>;
    _firstRowOffset: number;
    _cellPadding: string;
    _cellWidth: string;
    constructor(_elementRef: ElementRef<HTMLElement>, _ngZone: NgZone);
    _cellClicked(cell: NtCalendarCell, event: MouseEvent): void;
    _isSelected(value: number): boolean;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    _isActiveCell(rowIndex: number, colIndex: number): boolean;
    _focusActiveCell(movePreview?: boolean): void;
    _isRangeStart(value: number): boolean;
    _isRangeEnd(value: number): boolean;
    _isInRange(value: number): boolean;
    _isComparisonStart(value: number): boolean;
    _isComparisonBridgeStart(value: number, rowIndex: number, colIndex: number): boolean;
    _isComparisonBridgeEnd(value: number, rowIndex: number, colIndex: number): boolean;
    _isComparisonEnd(value: number): boolean;
    _isInComparisonRange(value: number): boolean;
    _isComparisonIdentical(value: number): boolean;
    _isPreviewStart(value: number): boolean;
    _isPreviewEnd(value: number): boolean;
    _isInPreview(value: number): boolean;
    private _enterHandler;
    private _leaveHandler;
    private _getCellFromElement;
}
