import { Subject } from 'rxjs';
import { AfterContentInit, ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtCalendarCellClassFunction, NtCalendarUserEvent } from './calendar-body.component';
import { DateRange } from './selections';
import { NtCalendarMonth } from './month.component';
import { NtCalendarMultiYear } from './multi-year.component';
import { NtCalendarYear } from './year.component';
export declare type NtDatePickerViewType = 'month' | 'year' | 'multi-year';
export declare class NtDatePickerCalendar<D> implements AfterContentInit, OnChanges, OnDestroy {
    private _changeDetectorRef;
    private _dateAdapter;
    private _dateFormats;
    private _moveFocusOnNextTick;
    startView: NtDatePickerViewType;
    private _startAt;
    get startAt(): D | null;
    set startAt(value: D | null);
    private _selected;
    get selected(): DateRange<D> | D | null;
    set selected(value: DateRange<D> | D | null);
    private _minDate;
    get minDate(): D | null;
    set minDate(value: D | null);
    private _maxDate;
    get maxDate(): D | null;
    set maxDate(value: D | null);
    stateChanges: Subject<void>;
    dateFilter: (date: D) => boolean;
    dateClass: NtCalendarCellClassFunction<D>;
    comparisonStart: D | null;
    comparisonEnd: D | null;
    readonly selectedChange: EventEmitter<D | null>;
    readonly yearSelected: EventEmitter<D>;
    readonly monthSelected: EventEmitter<D>;
    readonly viewChanged: EventEmitter<NtDatePickerViewType>;
    readonly _userSelection: EventEmitter<NtCalendarUserEvent<D | null>>;
    monthView: NtCalendarMonth<D>;
    yearView: NtCalendarYear<D>;
    multiYearView: NtCalendarMultiYear<D>;
    private _currentView;
    get currentView(): NtDatePickerViewType;
    set currentView(value: NtDatePickerViewType);
    private _clampedActiveDate;
    get activeDate(): D;
    set activeDate(value: D);
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats);
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewChecked(): void;
    ngOnDestroy(): void;
    focusActiveCell(): void;
    updateTodaysDate(): void;
    _dateSelected(event: NtCalendarUserEvent<D | null>): void;
    _yearSelectedInMultiYearView(normalizedYear: D): void;
    _monthSelectedInYearView(normalizedMonth: D): void;
    _goToDateInView(date: D, view: 'month' | 'year' | 'multi-year'): void;
    private _getCurrentViewComponent;
}
