import { Subject } from 'rxjs';
import { CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { CdkPortalOutlet, Portal } from '@angular/cdk/portal';
import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtOverlayComponent } from '@ng-tangram/components/overlay';
import { NtCalendarCellClassFunction } from './calendar-body.component';
import { NtDatePickerControl } from './datepicker-control';
import { NtDatePickerIcons } from './datepicker-icons';
import { ExtractDateTypeFromSelection, NtDateSelectionModel } from './selections/date-selection-model';
export declare abstract class NtDatePickerBase<S, D = ExtractDateTypeFromSelection<S>> implements NtDatePickerControl<D>, AfterViewInit, OnChanges, OnDestroy {
    icons: NtDatePickerIcons;
    protected _dateFormats: NtDateFormats;
    protected _changeDetectorRef: ChangeDetectorRef;
    protected _dateAdapter: DateAdapter<D>;
    protected _model: NtDateSelectionModel<S, D>;
    private _overlayToggle;
    tabIndex: number;
    _portal: Portal<any>;
    _positionPairs: ConnectionPositionPair[];
    private _startAt;
    get startAt(): D | null;
    set startAt(value: D | null);
    private _min;
    get min(): D | null;
    set min(value: D | null);
    private _max;
    get max(): D | null;
    set max(value: D | null);
    dateClass: NtCalendarCellClassFunction<D>;
    dateFilter: (date: D) => boolean;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    overlay: NtOverlayComponent;
    _portalOutlet: CdkPortalOutlet;
    protected abstract _isActivated(): boolean;
    protected abstract _getStartValue(): D | null;
    protected abstract _getDefaultModelValue(): S;
    protected abstract _formatValue(modelValue: S): void;
    readonly origin: CdkOverlayOrigin;
    readonly _stateChanges: Subject<void>;
    constructor(elementRef: ElementRef, tabIndex: string, icons: NtDatePickerIcons, _dateFormats: NtDateFormats, _changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _model: NtDateSelectionModel<S, D>);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    focus(): void;
    select(date: D): void;
    _onAfterOpen(event: any): void;
    _onAfterClosed(event: any): void;
    _onBeforeOpen(event: any): void;
    _onBeforeClosed(event: any): void;
    _onPositionChange(change: ConnectedOverlayPositionChange): void;
    _onClick(event: Event): void;
    _onClear(event: Event): void;
}
