import { Subject } from 'rxjs';
import { CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { CdkPortalOutlet, Portal } from '@angular/cdk/portal';
import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { NgControl, ValidationErrors, ValidatorFn } from '@angular/forms';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtOverlayComponent } from '@ng-tangram/components/overlay';
import { NtCalendarCellClassFunction } from './calendar-body.component';
import { DateFilterFn, NtDatePickerControl } from './datepicker-control';
import { NtDatePickerIcons } from './datepicker-icons';
import { NtDatePickerInputBase } from './datepicker-input-base';
import { NtDateSelectionModel } from './selections';
export declare class NtDatePicker<D> extends NtDatePickerInputBase<D | null, D> implements NtFormFieldControl<D>, NtDatePickerControl<D>, AfterViewInit, OnChanges, OnDestroy {
    _elementRef: ElementRef;
    icons: NtDatePickerIcons;
    private _dateFormats;
    private _changeDetectorRef;
    ngControl: NgControl;
    private _overlayToggle;
    _displayValue: string;
    id: string;
    tabIndex: number;
    _portal: Portal<any>;
    _positionPairs: ConnectionPositionPair[];
    private _startAt;
    get startAt(): D | null;
    set startAt(value: D | null);
    private _min;
    get min(): D | null;
    set min(value: D | null);
    private _max;
    get max(): D | null;
    set max(value: D | null);
    private _placeholder;
    set placeholder(value: string);
    get placeholder(): string;
    private _readonly;
    set readonly(value: boolean);
    get readonly(): boolean;
    dateClass: NtCalendarCellClassFunction<D>;
    dateFilter: (date: D) => boolean;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    overlay: NtOverlayComponent;
    _portalOutlet: CdkPortalOutlet;
    _validator: ValidatorFn;
    readonly origin: CdkOverlayOrigin;
    readonly _stateChanges: Subject<void>;
    constructor(_elementRef: ElementRef, tabIndex: string, icons: NtDatePickerIcons, _dateFormats: NtDateFormats, _changeDetectorRef: ChangeDetectorRef, dateAdapter: DateAdapter<D>, _model: NtDateSelectionModel<D, D>, ngControl: NgControl);
    focused?: boolean;
    empty?: boolean;
    getErrors(): ValidationErrors | null;
    _isActivated(): boolean;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    focus(): void;
    select(date: D): void;
    _onAfterOpen(event: any): void;
    _onAfterClosed(event: any): void;
    _onBeforeOpen(event: any): void;
    _onBeforeClosed(event: any): void;
    _onPositionChange(change: ConnectedOverlayPositionChange): void;
    _onClick(event: Event): void;
    _onClear(event: Event): void;
    _assignValueToModel(value: D | null): void;
    _getValueFromModel(modelValue: D): D;
    _getMinDate(): D | null;
    _getMaxDate(): D | null;
    _getDateFilter(): DateFilterFn<D>;
    _getStartValue(): D | null;
    protected _formatValue(modelValue: D | null): void;
    protected _getDefaultModelValue(): D | null;
}
