import { AfterContentInit, ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { DateAdapter } from '@ng-tangram/components/core';
import { NtCalendarBody, NtCalendarCell, NtCalendarCellClassFunction, NtCalendarUserEvent } from './calendar-body.component';
export declare class NtCalendarMultiYear<D> implements AfterContentInit, OnDestroy {
    private _changeDetectorRef;
    _dateAdapter: DateAdapter<D>;
    private _rerenderSubscription;
    private _activeDate;
    get activeDate(): D;
    set activeDate(value: D);
    private _selected;
    get selected(): D | null;
    set selected(value: D | null);
    private _minDate;
    get minDate(): D | null;
    set minDate(value: D | null);
    private _maxDate;
    get maxDate(): D | null;
    set maxDate(value: D | null);
    dateFilter: (date: D) => boolean;
    dateClass: NtCalendarCellClassFunction<D>;
    readonly selectedChange: EventEmitter<D>;
    readonly yearSelected: EventEmitter<D>;
    readonly activeDateChange: EventEmitter<D>;
    _calendarBody: NtCalendarBody;
    _years: NtCalendarCell[][];
    _todayYear: number;
    _selectedYear: number | null;
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    _init(): void;
    _yearSelected(event: NtCalendarUserEvent<number>): void;
    _getActiveCell(): number;
    _focusActiveCell(): void;
    private _createCellForYear;
    private _shouldEnableYear;
    private _setSelectedYear;
}
